#!/bin/sh
### BEGIN INIT INFO
# Provides:          dhclient
# Required-Start:    networking $syslog 
# Required-Stop:     
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: starts dhcp client 
# Description:       starts dhcp client
### END INIT INFO
#
PIDFILE=/var/run/dhclient.pid

case "$1" in
    start)
	# look for special token emitted by GUI (ipv4configlib.c)
	# to determine whether we're supposed to run DHCP

        if grep '#IPv4UseDHCP=1' /etc/network/interfaces > /dev/null; then
            echo -n 'starting dhcp client'
            /sbin/dhclient -pf "$PIDFILE" -nw eth0
            echo '.'
	else
	    # make sure there's no PID file left over from a previous run
	    rm -f "$PIDFILE"
        fi
        ;;
    stop)
        if [ -f "$PIDFILE" ] ; then
	    echo -n 'stopping dhcp client'
	    # -x means kill the dhcp client without giving up existing lease
	    # (so when we reboot, we're more likely to get the same IP addr)
	    /sbin/dhclient -pf "$PIDFILE" -x
	    echo '.'
	    # "it was a mercy killing!"
        fi
        ;;
    *)
        echo 'usage: /etc/init.d/dhclient.sh {start|stop}' >&2
        exit 1
        ;;
esac
