#!/bin/sh
### BEGIN INIT INFO
# Provides:          m1700
# Required-Start:    networking $syslog $time
# Required-Stop:     
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: provides back end to model 1700 user interface
# Description:       This daemon implements: monitoring of the dewar
#		     sensors, alarms, autofill, and generation of
#		     variables used by the user interface.
### END INIT INFO
#
#
systemctl stop serial-getty@ttymxc0.service 

M1700=/webgui/sbin/1700
PIDFILE=/var/run/m1700.pid
M1700hardw=/webgui/sbin/1700hardware
PIDFILEhardw=/var/run/m1700hardware.pid
M1700gui=/webgui/sbin/1700gui
PIDFILEgui=/var/run/1700gui.pid
Mncscpi=/etc/init.d/ncscpi.sh
PIDFILEncscpi=/var/run/ncscpi.pid
Mscpiserial=/webgui/sbin/scpiserial
PIDFILEscpiserial=/var/run/scpiserial.pid

# now set up ports
if [ ! -f /sys/class/gpio/gpio232/direction ]; then  # only exists if port set up already
	/etc/init.d/setup-ts4900-ports.sh   
	sleep 1
fi
export TSLIB_TSDEVICE=/dev/input/event0

#
# insure that user accessible areas are user accessible
#
chmod 777 /webgui/log
chmod 777 /webgui/log/*
chmod 777 /update
chmod 777 /update/*
chmod 777 /webgui/configuration
chmod 777 /webgui/configuration/*

/webgui/util/shmem_init ScpiRS232 "1" >/dev/null 

#
#
#
case "$1" in
	start)
	echo -n 'starting 17XX daemons'
# 256 meg ramdisk for history
	mkdir /tmp/ramdisk
	chmod 777 /tmp/ramdisk
	mount -t tmpfs -o size=256m ramdisk /tmp/ramdisk
	touch /webgui/log/N2-1.log
	touch /webgui/log/N2-2.log
	touch /webgui/log/He.log
	cp -a /webgui/log/N2-1.log /tmp/ramdisk/N2-1.log
	cp -a /webgui/log/N2-2.log /tmp/ramdisk/N2-2.log
	cp -a /webgui/log/He.log /tmp/ramdisk/He.log

	/sbin/start-stop-daemon --start --quiet --background -m --pidfile $PIDFILEhardw --exec $M1700hardw
	sleep 3
	/sbin/start-stop-daemon --start --quiet --background -m --pidfile $PIDFILEgui --exec $M1700gui
	sleep 3
	/sbin/start-stop-daemon --start --quiet --background -m --pidfile $PIDFILEncscpi --exec $Mncscpi
	sleep 3
	/sbin/start-stop-daemon --start --quiet --background -m --pidfile $PIDFILE --exec $M1700
	/sbin/start-stop-daemon --start --quiet --background -m --pidfile $PIDFILEscpiserial --exec $Mscpiserial
#	/etc/init.d/ncscpi.sh &
	;;
	stop)
	echo -n 'stopping 1700 daemons'
	/sbin/start-stop-daemon --stop --quiet --pidfile $PIDFILE
	/sbin/start-stop-daemon --stop --quiet --pidfile $PIDFILEhardw
	/sbin/start-stop-daemon --stop --quiet --pidfile $PIDFILEgui
	/sbin/start-stop-daemon --stop --quiet --pidfile $PIDFILEncscpi
	/sbin/start-stop-daemon --stop --quiet --pidfile $PIDFILEscpiserial
#	killall ncscpi.sh
	killall nc
#	killall scpi
	v=`/webgui/util/shmem_get -t RunStatus` 
	if [ $v = "shutdown" ];	then
		cp /webgui/images/poweroff.img /dev/fb0
	else 
		if [ $v = "reboot" ];	then
			cp /webgui/images/reboot.img /dev/fb0
		fi
	fi
	;;
	*)
	echo 'usage: /etc/init.d/m1700.sh {start|stop}' >&2
	exit 1
	;;
esac
