#!/bin/sh
###

/webgui/util/shmem_init InstallMessage "Installing"  >/dev/null
if [ -f /proc/device-tree/model ]; then  # only exists on the ts4900
    cd /update/tmp/files/ts4900
fi

#/etc/init.d/m1700.sh stop
#/etc/init.d/m1700alerts.sh stop

backupconfigfile=$(hostname)"-"$(date +"%d-%m-%Y--%H-%M-%S").state
cp /webgui/state/model_1700.state /webgui/configuration/$backupconfigfile

mv /webgui/sbin/1700             /tmp/1700.i.will.go.away.on.reboot.like.tears.in.the.rain
if [ -f /proc/device-tree/model ]; then  # only exists on the ts4900
	mv /webgui/sbin/1700gui          /tmp/1700gui.i.will.go.away.on.reboot.like.tears.in.the.rain
	mv /webgui/sbin/1700hardware     /tmp/1700hardware.i.will.go.away.on.reboot.like.tears.in.the.rain
fi
mv /webgui/sbin/scpi             /tmp/scpi.i.will.go.away.on.reboot.like.tears.in.the.rain
mv /webgui/sbin/scpiserial       /tmp/scpiserial.i.will.go.away.on.reboot.like.tears.in.the.rain
mv /webgui/home/get_json.cgi     /tmp/get_json.cgi.i.will.go.away.on.reboot.like.tears.in.the.rain
mv /webgui/home/get_log.cgi      /tmp/get_log.cgi.i.will.go.away.on.reboot.like.tears.in.the.rain

/webgui/util/shmem_init InstallMessage "Creating directories"  >/dev/null
sleep 1

mkdir -p /webgui
mkdir -p /webgui/defaults
mkdir -p /webgui/helpers
mkdir -p /webgui/home
mkdir -p /webgui/home/images
mkdir -p /webgui/home/aml
mkdir -p /webgui/home/aml/1700
mkdir -p /webgui/home/aml/1720
mkdir -p /webgui/home/aml/1740
mkdir -p /webgui/images
mkdir -p /webgui/log
mkdir -p /webgui/sbin
mkdir -p /webgui/state
mkdir -p /webgui/util
mkdir -p /webgui/configuration
mkdir -p /update

chown webgui.webgui /webgui/state
chown webgui.webgui /webgui/helpers
chown root.root /webgui
chown root.root /webgui/home
chown root.root /webgui/home/images
chown root.root /webgui/home/aml
chown root.root /webgui/home/aml/1700
chown root.root /webgui/home/aml/1720
chown root.root /webgui/home/aml/1740
chown root.root /webgui/util
chown root.root /webgui/defaults
chown root.root /webgui/images
chown root.root /webgui/log
chown root.root /webgui/sbin
chown root.root /update
chown root.root /webgui/configuration

chmod 751 /webgui
chmod 555 /webgui/defaults
chmod 700 /webgui/helpers
chmod 755 /webgui/home
chmod 777 /webgui/home/aml
chmod 777 /webgui/home/aml/1700
chmod 777 /webgui/home/aml/1720
chmod 777 /webgui/home/aml/1740
#chmod 755 /webgui/home/aml
#chmod 755 /webgui/home/aml/1700
#chmod 755 /webgui/home/aml/1720
chmod 755 /webgui/home/images
chmod 755 /webgui/images
chmod 777 /webgui/log
chmod 755 /webgui/sbin
chmod 775 /webgui/state
chmod 700 /webgui/util
chmod 777 /webgui/configuration
chmod 777 /webgui/log
chmod 777 /update

# copy everything into its proper place
#cp  -vr webgui/* /webgui/ >list1
#cp  -vr etc/init.d/* /etc/init.d/ >list2
#cp  -vr etc/pam.d/mtestd.pam /etc/pam.d/mtestd >list3
#cat list* >manifest
#rm list*

/webgui/util/shmem_init InstallMessage "Copying 1 of 3"  >/dev/null

mkdir -p /tmp/state
cp -p /webgui/state/* /tmp/state

rm /webgui/home/aml/*.*
rm /webgui/home/aml/1700/*.*
rm /webgui/home/aml/1720/*.*
rm /webgui/home/aml/1740/*.*
rm /webgui/home/*.cgi
rm /webgui/helpers/*
rm /webgui/sbin/*

cp  -r webgui/* /webgui/  >/dev/null
mv  /webgui/logging_description.txt /webgui/log  >/dev/null
sleep 1

/webgui/util/shmem_init InstallMessage "Copying 2 of 3"  >/dev/null
cp -p /tmp/state/* /webgui/state
sleep 1

/webgui/util/shmem_init InstallMessage "Copying 3 of 3."  >/dev/null
cp  -r etc/init.d/m1700.sh /etc/init.d/  >/dev/null
cp  -r etc/init.d/dhclient.sh /etc/init.d/  >/dev/null
cp  -r etc/init.d/ncscpi.sh /etc/init.d/  >/dev/null

#cp  -r etc/pam.d/mtestd.pam /etc/pam.d/mtestd  >/dev/null

sleep 1

if [ -f /proc/device-tree/model ]; then  # only exists on the ts4900
#	v=`/webgui/util/shmem_get -t hardware_type`    # this only works if the new shmem_get is already installed...
	echo 61  > /sys/class/gpio/unexport
	echo 59  > /sys/class/gpio/unexport
	echo 55  > /sys/class/gpio/unexport

	echo 61  > /sys/class/gpio/export
	echo 59  > /sys/class/gpio/export
	echo 55  > /sys/class/gpio/export

	echo out  > /sys/class/gpio/gpio61/direction
	echo out  > /sys/class/gpio/gpio59/direction
	echo in  > /sys/class/gpio/gpio55/direction
	
	echo 1 >  /sys/class/gpio/gpio61/value		# init lines
	echo 1 >  /sys/class/gpio/gpio59/value

	echo 0 >  /sys/class/gpio/gpio61/value		# load the 74hc165's bits
	echo 1 >  /sys/class/gpio/gpio61/value

	v=$v`cat  /sys/class/gpio/gpio55/value`		# read the Qh bit
	echo 0 >  /sys/class/gpio/gpio59/value		# clock the 74hc165
	echo 1 >  /sys/class/gpio/gpio59/value

	v=$v`cat  /sys/class/gpio/gpio55/value`
	echo 0 >  /sys/class/gpio/gpio59/value
	echo 1 >  /sys/class/gpio/gpio59/value
#read the 6 more bits if board rev number is needed with the above three line of code or some variant
	bv=$v`cat  /sys/class/gpio/gpio55/value`
	echo 0 >  /sys/class/gpio/gpio59/value
	echo 1 >  /sys/class/gpio/gpio59/value
	
	bv=$bv`cat  /sys/class/gpio/gpio55/value`
	echo 0 >  /sys/class/gpio/gpio59/value
	echo 1 >  /sys/class/gpio/gpio59/value
	
	bv=$bv`cat  /sys/class/gpio/gpio55/value`
	echo 0 >  /sys/class/gpio/gpio59/value
	echo 1 >  /sys/class/gpio/gpio59/value
	
	bv=$bv`cat  /sys/class/gpio/gpio55/value`
	echo 0 >  /sys/class/gpio/gpio59/value
	echo 1 >  /sys/class/gpio/gpio59/value
	
	bv=$bv`cat  /sys/class/gpio/gpio55/value`
	echo 0 >  /sys/class/gpio/gpio59/value
	echo 1 >  /sys/class/gpio/gpio59/value
	
	bv=$bv`cat  /sys/class/gpio/gpio55/value`
	echo $bv >  /webgui/log/hwbyte.txt
	
	if [ $v = "00" ];	then
		/webgui/util/shmem_init InstallMessage "Copying fpga and setup for 1720"  >/dev/null
		cp  -r ts4900_top_bitmap-1720.bin /boot/ts4900-fpga.bin  >/dev/null
		cp  -r etc/init.d/setup-model1720-ports.sh /etc/init.d/setup-ts4900-ports.sh  >/dev/null
	else
		if [ $v = "11" ];	then
			/webgui/util/shmem_init InstallMessage "Copying fpga and setup for 1700"  >/dev/null
		else
			/webgui/util/shmem_init InstallMessage "Unknown model; assuming 1700"  >/dev/null
			sleep 1
			/webgui/util/shmem_init InstallMessage "Copying fpga for 1700"  >/dev/null
		fi
		cp  -r ts4900_top_bitmap-1700.bin /boot/ts4900-fpga.bin  >/dev/null
		cp  -r etc/init.d/setup-model1700-ports.sh /etc/init.d/setup-ts4900-ports.sh  >/dev/null
	fi
	sleep 1
fi

/webgui/util/shmem_init InstallMessage "Installing system.conf"  >/dev/null
cp  -r system.conf /etc/systemd/system.conf  >/dev/null
sleep 1

/webgui/util/shmem_init InstallMessage "Doing chown/chmod"  >/dev/null
sleep 1

chown root.root /webgui/home/*.cgi
chown root.root /webgui/home/aml /webgui/home/aml/1700 /webgui/home/aml/1720  /webgui/home/aml/1740 /webgui/home/aml/*
chown root.root /webgui/helpers/*
chown root.root /webgui/util/*

chmod 755 /webgui/home/*.cgi
chmod 777 /webgui/home/aml/*.aml
chmod 777 /webgui/home/aml/1700/*.aml
chmod 777 /webgui/home/aml/1720/*.aml
chmod 777 /webgui/home/aml/1740/*.aml
#chmod 644 /webgui/home/aml/*.aml
#chmod 644 /webgui/home/aml/1700/*.aml
#chmod 644 /webgui/home/aml/1720/*.aml
chmod 644 /webgui/home/images/*
chmod 644 /webgui/images/*
chmod 500 /webgui/util/*
chmod 4755 /webgui/helpers/*
chmod 766 /webgui/state/*

update-rc.d m1700.sh defaults

# mailalerts commented out until ready
#update-rc.d m1700alerts.sh remove
#update-rc.d dhclient.sh defaults
if [ -f /proc/device-tree/model ]; then  # only exists on the ts4900
	/webgui/util/shmem_init InstallMessage "Copying Kernel"  >/dev/null
	sleep 1
#	update-rc.d m1700hardware.sh remove
#	update-rc.d m1700Cgui.sh remove
#	update-rc.d m1700hardware.sh defaults
#	update-rc.d m1700Cgui.sh defaults
	cp uImage /boot/uImage						# uncomment to update the kernel
	cp imx6dl-ts4900-3f.dtb /boot/imx6dl-ts4900-3f.dtb
	cp imx6q-ts4900-3f.dtb /boot/imx6q-ts4900-3f.dtb
fi

/webgui/util/shmem_init InstallMessage "Done"  >/dev/null

#mkdir -p /update/src
#cd /update/src
#tar -xf /update/tmp/files/ts4900/src.tar.gz || true


#rm -rf /update/tmp
