server_url = 'get_json_new.cgi';
generation = 0;

amllib_blinkstate = 1;
amllib_cursor = [0, 0, 0, 0];  // [ x, y, xincr, yincr ] (units: "pixels" based on a 480x272 "pixel" window)
amllib_graph_called = false;
amllib_next_cursor = [0, 0, 0, 0];
amllib_includes = [];
amllib_last_y = 0;
amllib_objects = {};
amllib_options = {
    // for now this is just used to debug placement on the window
    //"border": "thin solid magenta"
};
amllib_timer_interval = 100;
amllib_poll_interval = 1000;    // in milliseconds
amllib_last_interval = null;
amllib_request_time = null;     // timestamp of last XMLHttpRequest issued
amllib_requests = [];
amllib_format_requested = false;
amllib_ntp_requested = false;
amllib_autofill1statechange_requested = false;
amllib_autofill2statechange_requested = false;
amllib_installupdate_requested = false;
amllib_factoryreset_requested = false;
amllib_createfactoryreset_requested = false;
amllib_save_requested = false;
amllib_cancel_requested = false;
amllib_cancel_vars = {};        // vars maintained on the 1720 (mostly autofill
amllib_goto_link = null;
								// control) that might need to be cancelled
amllib_autosave_requested = false;
amllib_autosave_vars = [];
amllib_timer = null;
amllib_vars = {};
amllib_writethrough = true;     // treat local vars as a writethough cache of shared memory
amllib_17xx_save_vars = {};     // variables on the 17xx to save if save is pressed
amllib_17xx_watch_vars = {};    // variables on the 17xx to watch in case they are modified

s_browser_timezone = Intl.DateTimeFormat().resolvedOptions.timeZone;

// old versions of MSIE lack Date.now() function so fix this
if (!Date.now) {
    Date.now = function () { return new Date.getTime(); }
}

graph_line = null;
if (ami_model == '1700') {
    gshowN2_1 = 1;
    gshowN2_2 = 0;
    gshowHe = 1;
    s_hst_n2_1_show = 1;
    s_hst_n2_2_show = 0;
    s_hst_heshow = 1;
}
else if (ami_model == '1720') {
    gshowN2_1 = 1;
    gshowN2_2 = 1;
    gshowHe = 0;
    s_hst_n2_1_show = 1;
    s_hst_n2_2_show = 1;
    s_hst_heshow = 0;
}
gposition = 0;
gzoomi = 1;
MAXGRAPHDATAPOINTS = 300;
MAXHISTZOOMS = 13; // 20;

// each item in amllib_vars:
// .current_value
// .cancel_value
// .editable (Boolean)
// .initialized (Boolean)
// .local_referenced (Boolean)
// .modified (Boolean)
// .shmem_key (string, mixed-case key)

function amlvar(name) {
    // constructor for amllib_vars member
    result = {};
    if (name.length > 1 && name[name.length-1] == '#') {
        result.local_referenced = true;
        result.shmem_key = name.substr(0, name.length-1);
    }
    else {
        result.local_referenced = false;
        result.shmem_key = name;
    }
    result.current_value = '';
    result.cancel_value = '';
    result.editable = false;
    result.initialized = false;
    result.modified = false;
    return result;
}

// initialize s_ variables not handled in genjs.c
s_alarms = 0;
s_var_modified = 0;  // XXX update this if vars have been modified
s_local_var_modified = 0;
s_doesexistfactoryresetfile = false;
s_hst_n2show = false;
s_alarmtext = "";
s_autofilltext = "";
s_nlistedfiles = 0;
s_updatedir = null;
s_updatefilename0 = "";
s_updatefilename1 = "";
s_updatefilename_desc = "";
s_isbrowser = 1;

monthnames = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun",
               "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];

function find_object_uid(e) {
    for (var uid in amllib_objects) {
        if ('object' in amllib_objects[uid] && 
            (e.target == amllib_objects[uid].object ||
             e.toElement == amllib_objects[uid].object)) {
            return uid;
        }
    }
    return null;
}
function find_uid_by_id(id) {
    for (var uid in amllib_objects) {
        if ('id' in amllib_objects[uid] && amllib_objects[uid].id == id)
            return uid;
    }
    return -1;
}
function get_value(name) {
    var id = name.toLowerCase();

    if (id.length > 1 && id[id.length-1] == '#')
        id = id.substr(0, id.length-1);
    if (id in amllib_vars && amllib_vars[id].initialized)
        return amllib_vars[id].current_value;
    return null;
}
function set_value(name, val) {
    var id = name.toLowerCase();

    if (id.length > 1 && id[id.length-1] == '#')
        id = id.substr(0, id.length-1);
    if (! (id in amllib_vars))
        amllib_vars[id] = amlvar(name);
    amllib_vars[id].current_value = val;
    amllib_vars[id].modified = true;
    amllib_vars[id].initialized = true;
    s_local_var_modified = 1;
}
function set_value_u(name, val) {
    var id = name.toLowerCase();

    if (id.length > 1 && id[id.length-1] == '#')
        id = id.substr(0, id.length-1);
    if (! (id in amllib_vars))
        amllib_vars[id] = amlvar(name);
    amllib_vars[id].current_value = val;
    amllib_vars[id].cancel_value = val;
    amllib_vars[id].initialized = true;
}
function get_cursor() {
    var result = amllib_cursor;

    amllib_cursor = amllib_next_cursor;
    return result;
}
function twodigit(d) {
    if (d < 0)
        return "" + d;
    else if (d < 10)
        return "0" + d;
    else
        return "" + d;
}

function s_DateTime() {
    // XXX need to get this from server since we want to show server
    //     time rather than browser time

    d = new Date();
    return (twodigit(d.getDay()) + " " +
            monthnames[d.getMonth()] + " " +
            d.getFullYear() + " " +
            twodigit(d.getHours()) + ":" +
            twodigit(d.getMinutes()) + ":" +
            twodigit(d.getSeconds()));
}

function y_percent(y) {
    // determine the y coordinate of a display feature
    // y parameter is in percent of container height
    // returned value is in percent of container height
    // (assuming 272 x 480 display)
    var result;

    if (typeof y == "string" || y instanceof String) {
        if (y[0] == '+') {
            // add yincr percent to y cursor value for each '+'
            // NOTE: this is a post-increment!
            var numplus = 0;

            for (i = 0; y[i] == '+' && i < y.length; ++i)
                numplus++;
            result = amllib_cursor[1];
            amllib_cursor[1] = amllib_cursor[1] + (numplus * amllib_cursor[3]);
            if (y[y.length-1] == '^') {
                // add 3 scaled pixels
                result = result + ((3 / 272.0) * 100.0);
            }
            else if (y[y.length-1] == 'v') {
                // subtract 3 scaled pixels
                result = result - ((3 / 272.0) * 100.0);
            }
            return result;
        }
        else if (y == '=') {
            return amllib_cursor[1];
        }
        else if (y == '=^') {
            return amllib_cursor[1] + ((3 / 272.0) * 100.0);
        }
        else if (y == '=v') {
            return amllib_cursor[1] - ((3 / 272.0) * 100.0);
        }
        else {
            // should not happen
            // return (y / 272.0) * 100;
            return y;
        }
    }
    else {
        // y is in "pixels"
        // return (y / 272.0) * 100;
        return y;
    }
}
function tohex(i) {
    return "0123456789abcdef"[(i>>4) & 0xf] + "0123456789abcdef"[i & 0xf];
}
function makergb(c) {
    // convert rgb integer value to HTML #RRBBGG notation
    return "#" + tohex((c >> 16) & 0xff) + tohex((c >> 8) & 0xff) + tohex(c & 0xff);
}
function percent_y(h) {
    return ((h * 272.0) / 100.0) + "px";
}
function font_size(p) {
    // set HTML font size as 90% of specified size because the fonts browsers
    // use seem to be a bit larger than those that Cairo uses
    return ((p * 0.9) / 10.0) + 'em';
}
function bottom_fudge(fontsize) {
    // guess at the vertical distance between the baseline of some text and
    // the bottom of the element containing the text

    return (fontsize * 0.9) * 0.23;
}
function aml_add_var(name, editable) {
    // add a variable to the list of variables to be retrieved from the
    // 17xx unit, and also initialize some other flags

    var lcn;
    var shmem_key;
    var local_referenced;

    // alert('add variable:' + name);
    if (name.length > 1 && name[name.length-1] == '#') {
        shmem_key = name.substr(0, name.length-1);
        lcn = shmem_key.toLowerCase();
        local_referenced = true;
    }
    else {
        shmem_key = name;
        lcn = name.toLowerCase();
        local_referenced = false;
    }
    if (lcn in amllib_vars) {
        // if already editable and we're called with editable=false, don't reset it
        if (editable)
            amllib_vars[lcn].editable = true;
        // same for local_referenced
        if (local_referenced)
            amllib_vars[lcn].local_referenced = true;
    }
    else {
        amllib_vars[lcn] = amlvar(shmem_key);
        amllib_vars[lcn].editable = editable;
    }
    if (amllib_requests.indexOf(shmem_key) < 0)
        amllib_requests.push(shmem_key);
}
// XXX this should probably be implemented in get_json_new.cgi instead
function aml_s_alarms() {
    var result = 0;
    if (get_value ('LHe_Level_Annunciator') != 0)
        result = result + 1;
    else if (get_value ('LN2_1_Level_Annunciator') != 0)
        result = result + 1;
    else if (get_value ('LN2_2_Level_Annunciator') != 0)
        result = result + 1;
    else if (get_value ('LN2_1_Timeout_Annunciator') != 0)
        result = result + 1;
    else if (get_value ('LN2_2_Timeout_Annunciator') != 0)
        result = result + 1;
    else if (get_value ('LN2_1_SensorActive') != 2)
        result = result + 1;
    if (get_value('AutoFillMasterMode') == 0) // AUTOFILL_MODE_NORMAL
        if (get_value('LN2_2_SensorActive') != 2)
            result = result + 1;
    return result;
}
function aml_background(args, uid, generation) {
    // set background color (presumably for whole display)
    container.style.backgroundColor = makergb(args[0]);
}
function aml_bargraph(args, uid, generation) {
    // args
    // 0 source (string - variable name)
    // 1 color
    // 2 gravity             // XXX not implemented yet
    // 3 minspigot           // XXX not implemented yet
    // 4 maxspigot           // XXX not implemented yet
    // 5 x
    // 6 y
    // 7 xlen
    // 8 ylen

    var svgns = 'http://www.w3.org/2000/svg';

    if (!(uid in amllib_objects)) {
        var svg = document.createElementNS(svgns, 'svg');
        var rect_outer = document.createElementNS(svgns, 'rect');
        var rect_inner = document.createElementNS(svgns, 'rect');
        var line1bg = document.createElementNS(svgns, 'line');
        var line1fg = document.createElementNS(svgns, 'line');
        var line2bg = document.createElementNS(svgns, 'line');
        var line2fg = document.createElementNS(svgns, 'line');
        if (get_value('hardware_type') == 1720) {
            var line3bg = document.createElementNS(svgns, 'line');
            var line3fg = document.createElementNS(svgns, 'line');
            var line4bg = document.createElementNS(svgns, 'line');
            var line4fg = document.createElementNS(svgns, 'line');
        }
        var defs = document.createElementNS(svgns, 'defs');
        var marker = document.createElementNS(svgns, 'marker');
        var path = document.createElementNS(svgns, 'path');
        var marker_id = args[0] + '_marker';
        var fill1 = document.createElementNS(svgns, 'line');
        var fill2 = document.createElementNS(svgns, 'line');

        svg.id = args[0] + '_bargraph';
        svg.style.width = args[7] + '%';        // xlen
        svg.style.height = args[8] + '%';       // ylen
        if ('border' in amllib_options)
            svg.style.border = amllib_options.border;
        rect_outer.setAttributeNS(null, 'x', '20%');
        rect_outer.setAttributeNS(null, 'y', '0%');
        rect_outer.setAttributeNS(null, 'width', '75%');
        rect_outer.setAttributeNS(null, 'height', '100%');
        rect_outer.style.fill = 'black';
        rect_outer.style.stroke = makergb(args[1]);
        rect_inner.setAttributeNS(null, 'x', '21%');
        rect_inner.style.fill = makergb(args[1]);
        rect_inner.style.stroke = makergb(args[1]);

        line1bg.setAttributeNS(null, 'x1', '20%');
        line1bg.setAttributeNS(null, 'x2', '95%');
        // draw y at 80% initially just so there will be something there
        line1bg.setAttributeNS(null, 'y1', '80%');
        line1bg.setAttributeNS(null, 'y2', '80%');
        line1bg.style.stroke = makergb(args[1]);
        line1bg.style.strokeWidth = '0.05em';
        // line1bg.style.visibility = 'hidden';

        line1fg.setAttributeNS(null, 'x1', '20%');
        line1fg.setAttributeNS(null, 'x2', '95%');
        // draw y at 80% initially just so there will be something there
        line1fg.setAttributeNS(null, 'y1', '80%');
        line1fg.setAttributeNS(null, 'y2', '80%');
        line1fg.style.stroke = 'black'; // should be background color
        line1fg.style.strokeWidth = '0.05em';
        line1fg.style.strokeDasharray = '0.1em';
        // line1fg.style.visibility = 'hidden';

        line2bg.setAttributeNS(null, 'x1', '20%');
        line2bg.setAttributeNS(null, 'x2', '95%');
        // draw y at 20% initially just so there will be something there
        line2bg.setAttributeNS(null, 'y1', '20%');
        line2bg.setAttributeNS(null, 'y2', '20%');
        line2bg.style.stroke = makergb(args[1]);
        line2bg.style.strokeWidth = '0.05em';
        // line2bg.style.visibility = 'hidden';

        line2fg.setAttributeNS(null, 'x1', '20%');
        line2fg.setAttributeNS(null, 'x2', '95%');
        // draw y at 20% initially just so there will be something there
        line2fg.setAttributeNS(null, 'y1', '20%');
        line2fg.setAttributeNS(null, 'y2', '20%');        
        line2fg.style.stroke = 'black'; // should be background color
        line2fg.style.strokeWidth = '0.05em';
        line2fg.style.strokeDasharray = '0.1em';
        // line2fg.style.visibility = 'hidden';

        if (get_value('hardware_type') == 1720) {
            line3bg.setAttributeNS(null, 'x1', '20%');
            line3bg.setAttributeNS(null, 'x2', '95%');
            // draw y at 10% initially just so there will be something there
            line3bg.setAttributeNS(null, 'y1', '10%');
            line3bg.setAttributeNS(null, 'y2', '10%');
            line3bg.style.stroke = makergb(args[1]);
            line3bg.style.strokeWidth = '0.05em';
            // line2bg.style.visibility = 'hidden';
            
            line3fg.setAttributeNS(null, 'x1', '20%');
            line3fg.setAttributeNS(null, 'x2', '95%');
            // draw y at 10% initially just so there will be something there
            line3fg.setAttributeNS(null, 'y1', '10%');
            line3fg.setAttributeNS(null, 'y2', '10%');        
            line3fg.style.stroke = 'black'; // should be background color
            line3fg.style.strokeWidth = '0.05em';
            line3fg.style.strokeDasharray = '0.1em';
            // line2fg.style.visibility = 'hidden';
            
            line4bg.setAttributeNS(null, 'x1', '20%');
            line4bg.setAttributeNS(null, 'x2', '95%');
            // draw y at 90% initially just so there will be something there
            line4bg.setAttributeNS(null, 'y1', '90%');
            line4bg.setAttributeNS(null, 'y2', '90%');
            line4bg.style.stroke = makergb(args[1]);
            line4bg.style.strokeWidth = '0.05em';
            // line4bg.style.visibility = 'hidden';
            
            line4fg.setAttributeNS(null, 'x1', '20%');
            line4fg.setAttributeNS(null, 'x2', '95%');
            // draw y at 90% initially just so there will be something there
            line4fg.setAttributeNS(null, 'y1', '90%');
            line4fg.setAttributeNS(null, 'y2', '90%');        
            line4fg.style.stroke = 'black'; // should be background color
            line4fg.style.strokeWidth = '0.05em';
            line4fg.style.strokeDasharray = '0.1em';
            // line4fg.style.visibility = 'hidden';
        }
        marker.setAttribute('id', marker_id);
        marker.setAttribute('viewBox', '0 0 10 10');
        marker.setAttribute('refX', '0');
        marker.setAttribute('refY', '5');
        marker.setAttribute('markerUnits', 'strokeWidth');
        marker.setAttribute('markerWidth', '4');
        marker.setAttribute('markerHeight', '3');
        marker.setAttribute('orient', 'auto');
        marker.setAttribute('fill', makergb(args[1]));

        // XXX set fill1, fill2 attributes from old ml2 bargraph-arrow class
        path.setAttribute('d', 'M 0 0 L 10 5 L 0 10 z');
        fill1.setAttribute('x1', '2%');
        fill1.setAttribute('x2', '3%');
        // set at 5% initially
        fill1.setAttribute('y1', '5%');
        fill1.setAttribute('y2', '5%');
        fill1.setAttribute('stroke', makergb(args[1]));
        fill1.setAttribute('stroke-width', '0.1em');
        fill1.setAttribute('marker-end', 'url(#' + marker_id + ')');
        fill1.style.visibility = 'hidden';

        fill2.setAttribute('x1', '2%');
        fill2.setAttribute('x2', '3%');
        // set at 95% initially
        fill2.setAttribute('y1', '95%');
        fill2.setAttribute('y2', '95%');
        fill2.setAttribute('stroke', makergb(args[1]));
        fill2.setAttribute('stroke-width', '0.1em');
        fill2.setAttribute('marker-end', 'url(#' + marker_id + ')');
        fill2.style.visibility = 'hidden';

        marker.appendChild(path);
        defs.appendChild(marker);
        svg.appendChild(defs);

        svg.appendChild(fill1);
        svg.appendChild(fill2);
        svg.appendChild(rect_outer);
        svg.appendChild(rect_inner);
        svg.appendChild(line1bg);
        svg.appendChild(line1fg);
        svg.appendChild(line2bg);
        svg.appendChild(line2fg);
        if (get_value('hardware_type') == 1720) {
            svg.appendChild(line3bg);
            svg.appendChild(line3fg);
            svg.appendChild(line4bg);
            svg.appendChild(line4fg);
        }
        svg.style.display = 'none'; // don't draw yet, wait until xxx_draw()
        container.appendChild(svg);

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].object = svg;
        amllib_objects[uid].rect_outer = rect_outer;
        amllib_objects[uid].rect_inner = rect_inner;
        amllib_objects[uid].fill1 = fill1;
        amllib_objects[uid].fill2 = fill2;
        amllib_objects[uid].line1bg = line1bg;
        amllib_objects[uid].line1fg = line1fg;
        amllib_objects[uid].line2bg = line2bg;
        amllib_objects[uid].line2fg = line2fg;
        if (get_value('hardware_type') == 1720) {
            amllib_objects[uid].line3bg = line3bg;
            amllib_objects[uid].line3fg = line3fg;
            amllib_objects[uid].line4bg = line4bg;
            amllib_objects[uid].line4fg = line4fg;
        }        
        amllib_objects[uid].type = 'bargraph';
        amllib_objects[uid].variable = args[0];
        amllib_objects[uid].draw = aml_bargraph_draw;
        amllib_objects[uid].hide = aml_bargraph_hide;

        aml_add_var(args[0] + '_Level', false);
        aml_add_var(args[0] + '_Level_display', false);
        aml_add_var(args[0] + '_Level_AutoFill1Start_display');
        aml_add_var(args[0] + '_Level_AutoFill1Stop_display');
        aml_add_var(args[0] + '_Level_SetPoint1_display', false);
        aml_add_var(args[0] + '_Level_SetPoint2_display', false);
        if (get_value('hardware_type') == 1720) {
            aml_add_var(args[0] + '_Level_SetPoint3_display', false);
            aml_add_var(args[0] + '_Level_SetPoint4_display', false);
        }
    }
    else {
        svg = amllib_objects[uid].object;
        rect_inner = amllib_objects[uid].rect_inner;
        rect_outer = amllib_objects[uid].rect_outer;
        amllib_objects[uid].generation = generation;
    }

    // for some reason bargraph origin seems to be specified as top left
    // even though text origin is specified as bottom left
    get_cursor();
    svg.style.position = 'absolute';
    svg.style.left = args[5] + '%';         // x
    svg.style.top = args[6] + '%';          // y
}
function aml_bargraph_draw (uid) {
    var svg = amllib_objects[uid].object;
    var rect_inner = amllib_objects[uid].rect_inner;
    var rect_outer = amllib_objects[uid].rect_outer;
    var line1bg = amllib_objects[uid].line1bg;
    var line1fg = amllib_objects[uid].line1fg;
    var line2bg = amllib_objects[uid].line2bg;
    var line2fg = amllib_objects[uid].line2fg;
    var fill1 = amllib_objects[uid].fill1;
    var fill2 = amllib_objects[uid].fill2;
    var base_varname = amllib_objects[uid].variable;
    var display_varname = base_varname + '_Level_display';
    var level_varname = base_varname + '_Level';
    var setpoint1_varname = base_varname + '_Level_SetPoint1_display';
    var setpoint2_varname = base_varname + '_Level_SetPoint2_display';
    var fillstart_varname = base_varname + '_Level_AutoFill1Start_display';
    var fillstop_varname = base_varname + '_Level_AutoFill1Stop_Display';
    if (get_value('hardware_type') == 1720) {
        var line3bg = amllib_objects[uid].line3bg;
        var line3fg = amllib_objects[uid].line3fg;
        var line4bg = amllib_objects[uid].line4bg;
        var line4fg = amllib_objects[uid].line4fg;
        var setpoint3_varname = base_varname + '_Level_SetPoint3_display';
        var setpoint4_varname = base_varname + '_Level_SetPoint4_display';
    }

	var chan=2;
	if(base_varname=='LN2_1')
		chan=0;
	else if((base_varname=='LN2_2') || (base_varname=='LHe_2') || (base_varname=='LHe'))
		chan=1;

    // set bar height
    var levellc = level_varname.toLowerCase();
    level = 0;
    if (levellc in amllib_vars && amllib_vars[levellc].initialized) {
        level = get_value(levellc);
        if (level < 0)
            level = 0;
        if (level > 100)
            level = 100;
        rect_inner.setAttributeNS(null, 'y', (100 - level) + '%');
        rect_inner.setAttributeNS(null, 'width', '73%');
        rect_inner.setAttributeNS(null, 'height', level + '%');
    }
    else {
        // shouldn't happen but how to handle if it does?
        rect_inner.setAttributeNS(null, 'y', 100 + '%');
        rect_inner.setAttributeNS(null, 'width', '73%');
        rect_inner.setAttributeNS(null, 'height', '0%');
    }

    var level_text = get_value(display_varname.toLowerCase());
    // draw alarm setpoint #1
    var setpoint1_varname_lc = setpoint1_varname.toLowerCase();
    var alarm1source = get_value('alarm1source');
    if (setpoint1_varname_lc in amllib_vars &&
        amllib_vars[setpoint1_varname_lc].initialized) {
        var setpoint1 = get_value(setpoint1_varname_lc);
        if (level_text == 'LOS' || level_text == 'SHORT' || level_text == 'INV' ||
            level_text == 'UNCAL' || level_text == 'BOP') {
            line1bg.style.visibility = 'hidden';
            line1fg.style.visibility = 'hidden';
        }
        else if (setpoint1 < 0.0 || setpoint1 > 100.0) {
            line1bg.style.visibility = 'hidden';
            line1fg.style.visibility = 'hidden';
        }
        else {
            line1bg.setAttribute('y1', (100.0-setpoint1) + '%');
            line1bg.setAttribute('y2', (100.0-setpoint1) + '%');
            line1fg.setAttribute('y1', (100.0-setpoint1) + '%');
            line1fg.setAttribute('y2', (100.0-setpoint1) + '%');
			if((alarm1source != 2) && (chan == alarm1source))
			{
				line1bg.style.visibility = 'visible';
				line1fg.style.visibility = 'visible';
			}
			else
			{
				line1bg.style.visibility = 'hidden';
				line1fg.style.visibility = 'hidden';
			}
        }
    }
    else {
        line1bg.style.visibility = 'hidden';
        line1fg.style.visibility = 'hidden';
    }
    // draw alarm setpoint #2
    var setpoint2_varname_lc = setpoint2_varname.toLowerCase();
    var alarm2source = get_value('alarm2source');
    if (setpoint2_varname_lc in amllib_vars &&
        amllib_vars[setpoint2_varname_lc].initialized) {
        var setpoint2 = get_value(setpoint2_varname.toLowerCase());
        if (level_text == 'LOS' || level_text == 'SHORT' || level_text == 'INV' ||
            level_text == 'UNCAL' || level_text == 'BOP') {
            line2bg.style.visibility = 'hidden';
            line2fg.style.visibility = 'hidden';
        }
        else if (setpoint2 < 0.0 || setpoint2 > 100.0) {
            line2bg.style.visibility = 'hidden';
            line2fg.style.visibility = 'hidden';
        }
        else {
            line2bg.setAttribute('y1', (100.0-setpoint2) + '%');
            line2bg.setAttribute('y2', (100.0-setpoint2) + '%');
            line2fg.setAttribute('y1', (100.0-setpoint2) + '%');
            line2fg.setAttribute('y2', (100.0-setpoint2) + '%');
			if((alarm2source != 2) && (chan == alarm2source))
			{
				line2bg.style.visibility = 'visible';
				line2fg.style.visibility = 'visible';
			}
			else
			{
				line2bg.style.visibility = 'hidden';
				line2fg.style.visibility = 'hidden';
			}
        }
    }
    else {
        line2bg.style.visibility = 'hidden';
        line2fg.style.visibility = 'hidden';
    }
    if (get_value('hardware_type') == 1720) {
        // draw alarm setpoint #3
        var setpoint3_varname_lc = setpoint3_varname.toLowerCase();
		var alarm3source = get_value('alarm3source');
       if (setpoint3_varname_lc in amllib_vars &&
            amllib_vars[setpoint3_varname_lc].initialized) {
            var setpoint3 = get_value(setpoint3_varname_lc);
            if (level_text == 'LOS' || level_text == 'SHORT' || level_text == 'INV' ||
                level_text == 'UNCAL' || level_text == 'BOP') {
                line3bg.style.visibility = 'hidden';
                line3fg.style.visibility = 'hidden';
            }
            else if (setpoint3 < 0.0 || setpoint3 > 100.0) {
                line3bg.style.visibility = 'hidden';
                line3fg.style.visibility = 'hidden';
            }
            else {
                line3bg.setAttribute('y1', (100.0-setpoint3) + '%');
                line3bg.setAttribute('y2', (100.0-setpoint3) + '%');
                line3fg.setAttribute('y1', (100.0-setpoint3) + '%');
                line3fg.setAttribute('y2', (100.0-setpoint3) + '%');
				if((alarm3source != 2) && (chan == alarm3source))
				{
					line3bg.style.visibility = 'visible';
					line3fg.style.visibility = 'visible';
				}
				else
				{
					line3bg.style.visibility = 'hidden';
					line3fg.style.visibility = 'hidden';
				}
            }
        }
        else {
            line3bg.style.visibility = 'hidden';
            line3fg.style.visibility = 'hidden';
        }
        // draw alarm setpoint #4
        var setpoint4_varname_lc = setpoint4_varname.toLowerCase();
 		var alarm4source = get_value('alarm4source');
		if (setpoint4_varname_lc in amllib_vars &&
            amllib_vars[setpoint4_varname_lc].initialized) {
            var setpoint4 = get_value(setpoint4_varname.toLowerCase());
            if (level_text == 'LOS' || level_text == 'SHORT' || level_text == 'INV' ||
                level_text == 'UNCAL' || level_text == 'BOP') {
                line4bg.style.visibility = 'hidden';
                line4fg.style.visibility = 'hidden';
            }
            else if (setpoint4 < 0.0 || setpoint4 > 100.0) {
                line4bg.style.visibility = 'hidden';
                line4fg.style.visibility = 'hidden';
            }
            else {
                line4bg.setAttribute('y1', (100.0-setpoint4) + '%');
                line4bg.setAttribute('y2', (100.0-setpoint4) + '%');
                line4fg.setAttribute('y1', (100.0-setpoint4) + '%');
                line4fg.setAttribute('y2', (100.0-setpoint4) + '%');
				if((alarm4source != 2) && (chan == alarm4source))
				{
					line4bg.style.visibility = 'visible';
					line4fg.style.visibility = 'visible';
				}
				else
				{
					line4bg.style.visibility = 'hidden';
					line4fg.style.visibility = 'hidden';
				}
            }
        }
        else {
            line4bg.style.visibility = 'hidden';
            line4fg.style.visibility = 'hidden';
        }
    }
    // fill start point
    fillstart = get_value(fillstart_varname);
	var disabled=true;
	var af1enabled = get_value('AutoFill1Enabled');
	var af2enabled = get_value('AutoFill2Enabled');
	var af1dewar = get_value('AutoFill1Dewar');
	var af2dewar = get_value('AutoFill2Dewar');
	var af1state = get_value('AutoFill1State');
	var af2state = get_value('AutoFill2State');
    if(get_value('hardware_type') == 1720)
	{
		if((chan==0 && af1enabled==1) && (chan==0 && af1dewar==1) && af1state!=0)   // AUTOFILL_DISABLED == 0
			disabled=false;
		if((chan==1 && af2enabled==1) && (chan==1 && af2dewar==2) && af2state!=0)
			disabled=false;
	}
	else if(get_value('hardware_type') == 1700)
	{
		if(chan==0 && get_value('AutoFill1Dewar')==1)
			disabled=false;
		if(chan==1 && get_value('AutoFill1Dewar')==2)
			disabled=false;
	}
		
    if (level_text == 'LOS' || level_text == 'SHORT' || level_text == 'INV' || 
        level_text == 'UNCAL' || level_text == 'BOP' || disabled) {
        fill1.style.visibility = 'hidden';
    }
    else if (fillstart < 0.0 || fillstart > 100.0)
        fill1.style.visibility = 'hidden';
    else {
        fill1.setAttribute ("y1", (100.0-fillstart)+"%");
        fill1.setAttribute ("y2", (100.0-fillstart)+"%");
        fill1.style.visibility = 'visible';
    }
    // fill stop point
    fillstop = get_value(fillstop_varname);
    if (level_text == 'LOS' || level_text == 'SHORT' || level_text == 'INV' || 
        level_text == 'UNCAL' || level_text == 'BOP' || disabled) {
        fill2.style.visibility = 'hidden';
    }
    else if (fillstop < 0.0 || fillstop > 100.0)
        fill2.style.visibility = 'hidden';
    else {
        fill2.setAttribute ("y1", (100.0-fillstop)+"%");
        fill2.setAttribute ("y2", (100.0-fillstop)+"%");
        fill2.style.visibility = 'visible';
    }
    
    svg.style.display = 'block';
}
function aml_bargraph_hide (uid) {
    var svg = amllib_objects[uid].object;

    svg.style.display = 'none';
}
function aml_cancel() {
    amllib_save_requested = false;
    // reset all local copies of variables
    for (var p in amllib_vars) {
        amllib_vars[p].current_value = amllib_vars[p].cancel_value;
        amllib_vars[p].initialized = true;
        amllib_vars[p].modified = false;
    }
    s_local_var_modified = 0;
    // if there are any attributes in amllib_cancel_vars, then do a
    // poll; otherwise just redraw the page.   
    //
    // Note that the for loop executes at most once.  There didn't
    // seem to be a good portable way of checking for whether an
    // object had any own properties without looping through them.
    //
    // In the words of the immortal S.E.K. formerly of Xerox and SDS
    // before that:  "I'm ashamed of this."
    for (var p in amllib_cancel_vars) {
        amllib_cancel_requested = true;
        aml_poll_now();
        return;
    }
    generation = generation + 1;
    aml_really_draw_page (generation);
    aml_hide_objects (generation);
    aml_show_objects (generation);
}
function aml_command(args, uid, generation) {
    // args
    // 0    label
    // 1    maxchars       // XXX what does this do?
    // 2    linkfilename   // XXX
    // 3    subcommand     // XXX
    // 4    fontsize
    // 5    en_labelcolor  
    // 6    dis_labelcolor // XXX need disable method
    // 7    en_buttoncolor 
    // 8    dis_buttoncolor // XXX need disable method
    // 9    x
    // 10   y


    if (!(uid in amllib_objects)) {
        var t = document.createElement('div');
        var text;

        if (args[0] in shmem_vars)
            text = document.createTextNode(get_value(args[0]));
        else if (args[3].startsWith('updatefilename')) {
            // on the first call we probably don't have updatefilenameN
            // in amllib_vars, so create an empty text element and add
            // it to the list of variables we poll for.   will update
            // the text element in aml_command_draw()
            aml_add_var(args[0], false);
            text = document.createTextNode('');
        }
        else
            text = document.createTextNode(args[0]);

        t.id = 'command_' + uid;
        t.appendChild(text);
        t.style.verticalAlign = 'text-bottom';
        t.style.fontSize = font_size(args[4]);
        t.style.color = makergb(args[5]);
        t.style.backgroundColor = makergb(args[7]);
        if ('border' in amllib_options)
            t.style.border = amllib_options.border;
        else {
            t.style.border = '2px';
            t.style.borderRadius = '0.3em';
        }
        t.style.display = 'none'; // don't draw yet
        t.style.boxShadow = '0 1px 2px rgba(0,0,0,0.2)';
        t.style.paddingTop = '0.05em';
        t.style.paddingBottom = '0.05em';
        t.style.paddingLeft = '0.25em';
        t.style.paddingRight = '0.25em';
        t.style.cursor = 'pointer';
        t.style.outline = 'none';
        t.style.textDecoration = 'none';
        t.style.textShadow = '0 1px 1px rgba(0,0,0,0.3)';
        t.onclick = aml_command_onclick;
        container.appendChild(t);

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].label = args[0];
        amllib_objects[uid].object = t;
        amllib_objects[uid].textNode = text;
        amllib_objects[uid].type = 'command';
        amllib_objects[uid].linkfilename = args[2];
        amllib_objects[uid].subcommand = args[3];
        amllib_objects[uid].draw = aml_command_draw;
        amllib_objects[uid].hide = aml_command_hide;
        amllib_objects[uid].color = makergb(args[5]);
        amllib_objects[uid].bgcolor = makergb(args[7]);

        if (args[0] in shmem_vars)
            aml_add_var(args[0], false);

        // if we're doing LN2 sensor calibration we need to make
        // sure we're caching these variables, otherwise
        // set_value() on any of them may fail.

        if (args[3] == 'savecal') {
            aml_add_var('LN2_1_OscMaxLevelPeriod', true);
            aml_add_var('LN2_1_OscMaxPeriodDate', true);
            aml_add_var('LN2_1_OscMaxPeriodTime', true);
            aml_add_var('LN2_1_OscMinLevelPeriod', true);
            aml_add_var('LN2_1_OscMinPeriodDate', true);
            aml_add_var('LN2_1_OscMinPeriodTime', true);
            aml_add_var('LN2_1_OscNoSensorPeriod', true);
            aml_add_var('LN2_1_OscNoSensorPeriodTime', true);
            aml_add_var('LN2_1_OscNoSensorPeriodDate', true);
            aml_add_var('LN2_1_CalibrationMode', true);
            aml_add_var('LN2_2_OscMaxLevelPeriod', true);
            aml_add_var('LN2_2_OscMaxPeriodDate', true);
            aml_add_var('LN2_2_OscMaxPeriodTime', true);
            aml_add_var('LN2_2_OscMinLevelPeriod', true);
            aml_add_var('LN2_2_OscMinPeriodDate', true);
            aml_add_var('LN2_2_OscMinPeriodTime', true);
            aml_add_var('LN2_2_OscNoSensorPeriod', true);
            aml_add_var('LN2_2_OscNoSensorPeriodTime', true);
            aml_add_var('LN2_2_OscNoSensorPeriodDate', true);
            aml_add_var('LN2_2_CalibrationMode', true);
        }


        // special case code for changes to autofill mode
        // since this is managed on the 17XX.
        // (see also the skull and crossbones elsewhere
        // in this file)
        if (args[0] == 'AutoFillChan1StateStr' ||
            args[0] == 'AutoFillChan2StateStr' ||
            args[0] == 'AutoFillChan1ShrtStateStr' ||
            args[0] == 'AutoFillChan2ShrtStateStr') {
            // add a list of variables to the polling list that we
            // need to have on hand to implement other parts of
            // the UI
            aml_add_var('AutoFillChan1StateStr', false);
            aml_add_var('AutoFillChan2StateStr', false);
            aml_add_var('AutoFillChan1ShrtStateStr', false);
            aml_add_var('AutoFillChan2ShrtStateStr', false);
            aml_add_var('AutoFill1Dewar', false);
            aml_add_var('AutoFill2Dewar', false);
//            aml_add_var('AutoFill1StateChange', false);
//            aml_add_var('AutoFill2StateChange', false);
            aml_add_var('AutoFill1Mode', false);
            aml_add_var('AutoFill2Mode', false);
            aml_add_var('AutoFill1State', false);
            aml_add_var('AutoFill2State', false);
            
            // these shmem variables need to be unsaved when the
            // user hits CANCEL on this page
            amllib_cancel_vars['AutoFill1State'] = true;
            amllib_cancel_vars['AutoFill2State'] = true;

            // these shmem variables also need to be saved when user
            // hits SAVE on this page
            amllib_17xx_save_vars['AutoFill1State'] = true;
            amllib_17xx_save_vars['AutoFill2State'] = true;

            // add these shmem vars to the list to monitor on the 1720
            // so we'll know if they've been modified behind our back.
            amllib_17xx_watch_vars['AutoFill1State'] = true;
            amllib_17xx_watch_vars['AutoFill2State'] = true;
        }
    }
    else {
        t = amllib_objects[uid].object;
        amllib_objects[uid].color = makergb(args[5]);
        amllib_objects[uid].bgcolor = makergb(args[7]);
        amllib_objects[uid].generation = generation;
    }

    get_cursor ();
    t.style.position = 'absolute';
    t.style.left = args[9] + "%";
    y = y_percent(args[10]);
    t.style.bottom = ((100 - y) - bottom_fudge(args[4])) + "%";
}
function zooom() {
    return gtimeperdiv[gzoomi] * 10.0;
}
function aml_command_draw(uid) {
    var t = amllib_objects[uid].object;
    var textNode = amllib_objects[uid].textNode;
    var label = amllib_objects[uid].label;
    var color = amllib_objects[uid].color;
    var bgcolor = amllib_objects[uid].bgcolor;

    // sometimes the first argument to command() is interpreted as a variable name;
    // other times it's interpreted as a string constant.   So if it's in 
    // shmem_vars treat it as a variable name, otherwise treat it as a string.
    if (label in shmem_vars)
        textNode.textContent = get_value(label);
    else if (label.startsWith('s_updatefilename')) 
        textNode.textContent = get_value(label);
    else
        textNode.textContent = label;
    t.style.color = color;
    t.style.backgroundColor = bgcolor;
    t.style.display = 'block';
    // textNode.style.display = 'inline';
}
function aml_command_hide(uid) {
    var t = amllib_objects[uid].object;

    t.style.display = 'none';
}
function aml_command_onclick(e) {
    uid = find_object_uid (e);
    if (uid in amllib_objects && 'subcommand' in amllib_objects[uid]) {
        subcommand = amllib_objects[uid].subcommand;
        amllib_goto_link = amllib_objects[uid].linkfilename;
        
        //    _                 _
        //  _( )               ( )_
        // (_, |     __ __     | ,_)
        //    \ \   /  ^  \   / /
        //     \ \,/       \,/ /
        //       \| []   [] |/
        //        (_  /^\  _)
        //          \  ~  /
        //          /HHHHH\
        //        /'/{^^^}\'\
        //    _,/'/'  ^^^  '\'\,_
        //   (_, |           | ,_)
        //     (_)           (_)
        //
        // If we change the value of AutoFill?StateChange on the 17XX,
        // the code on the 17XX will automagically change the value of
        // AutoFill?State (as well as some other variables) to some
        // valid state based on various other factors.  Problem is,
        // that's still a temporary (unsaved) variable that shouldn't
        // be saved until the user hits SAVE.
        //
        // XXX I think but am not certain that it's sufficient to 
        //     monitor AutoFill?State to know whether there are 
        //     variables on the 17XX that need SAVEing.
        //
        // So we now have a special "query" function in get_json_new
        // that lets us query specific shmem variables to see if they've
        // been modified on the 17XX, even though the corresponding local
        // copy of that variable on the browser hasn't been modified.
        // 
        // (Hmmm.  the old get_json.cgi included xx_modified variables
        // in the list that it returned, so another way to do this
        // would be to have get_json_new.cgi be able to be queried for
        // xxx_modified variables.  That might be a bit simpler for
        // the CGI program, but the JavaScript code still needs to
        // know what variables to query.)
        
        if (subcommand == 'autofillbutton' || subcommand == 'autofill1button') {
            if (get_value('AutoFill1Dewar')) {
//                set_value('AutoFill1StateChange', 1);
//                amllib_autosave_vars.push('AutoFill1StateChange');
//                amllib_autosave_requested = true;
                amllib_autofill1statechange_requested = true;
                aml_poll_now();
            }
        }
        else if (subcommand == 'autofill2button') {
            if (get_value('AutoFill2Dewar')) {
//                set_value('AutoFill2StateChange', 1);
//                amllib_autosave_vars.push('AutoFill2StateChange');
//                amllib_autosave_requested = true;
                amllib_autofill2statechange_requested = true;
                aml_poll_now();
            }
        }
        else if (subcommand == 'cancel') {
            aml_cancel();
        }
        else if (subcommand == 'cancelcal') {
            // XXX is this right? -KM
            set_value('LN2_1_CalibrationMode', 0);
            amllib_autosave_vars.push('LN2_1_CalibrationMode');
            set_value('LN2_2_CalibrationMode', 0);
            amllib_autosave_vars.push('LN2_2_CalibrationMode');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'cancelnet') {
            // XXX not sure if this should be different than ordinary cancel now
            // XXX maybe add specific "net" vars to amllib_cancel_vars?
            aml_cancel();
        }
        else if (subcommand == 'createfactoryreset') {
            amllib_createfactoryreset_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'factoryreset') {
            amllib_factoryreset_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'hst_heshow') {
            gshowHe = 1 - gshowHe;
            s_hst_heshow = 1 - s_hst_heshow;
        }
        // XXX not used
        // else if (subcommand == 'hst_n2show') {
        //  gshowN2_1 = 1 - gshowN2_1;
        //  gshowN2_2 = 1 - gshowN2_2;
        //  s_hst_n2_1_show = 1 - s_hst_n2_1_show;
        //  s_hst_n2_2_show = 1 - s_hst_n2_2_show;
        // }
        else if (subcommand == 'hst_n2_1_show') {
            gshowN2_1 = 1 - gshowN2_1;
            s_hst_n2_1_show = 1 - s_hst_n2_1_show;
        }
        else if (subcommand == 'hst_n2_2_show') {
            gshowN2_2 = 1 - gshowN2_2;
            s_hst_n2_2_show = 1 - s_hst_n2_2_show;
        }
        else if (subcommand == 'hst_panbegin') {
            gposition = 0;
            aml_poll_now();
        }
        else if (subcommand == 'hst_panleft') {
            gposition = gposition + (0.1 * zooom());
            aml_poll_now();
        }
        else if (subcommand == 'hst_panright') {
            var t = -0.1 * zooom();

            if ((gposition + t) >= 0)
                gposition = gposition + t;
            aml_poll_now();
        }
        else if (subcommand == 'hst_zoomin') {
            gposition = gposition + 0.5 * zooom();
            gzoomi = gzoomi - 1;
            if (gzoomi >= MAXHISTZOOMS)
                gzoomi = MAXHISTZOOMS - 1;
            if (gzoomi < 0)
                gzoomi = 0;
            gposition = gposition - 0.5 * zooom();
            aml_poll_now();
        }
        else if (subcommand == 'hst_zoomout') {
            gposition = gposition - 0.5 * zooom();
            gzoomi = gzoomi + 1;
            if (gzoomi >= MAXHISTZOOMS)
                gzoomi = MAXHISTZOOMS - 1;
            if (gzoomi < 0)
                gzoomi = 0;
            gposition = gposition + 0.5 * zooom();
            aml_poll_now();
        }
        else if (subcommand == 'installupdate') {
            amllib_installupdate_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'maxcal1') {
            set_value('LN2_1_CalibrationMode', 1);
            amllib_autosave_vars.push('LN2_1_CalibrationMode');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'maxcal2') {
            set_value('LN2_2_CalibrationMode', 1);
            amllib_autosave_vars.push('LN2_2_CalibrationMode');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'measureheprobevoltage') {
            set_value_u('LHe_SampleRequest', 1);
            amllib_autosave_vars.push('LHe_SampleRequest');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'mincal1') {
            set_value('LN2_1_CalibrationMode', 2);
            amllib_autosave_vars.push('LN2_1_CalibrationMode');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'mincal2') {
            set_value('LN2_2_CalibrationMode', 2);
            amllib_autosave_vars.push('LN2_2_CalibrationMode');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'mute') {
            // XXX should perhaps be implemented in a helper program?
            set_value('AlarmMutedOnTouchscreen',
                      !get_value('AlarmMutedOnTouchscreen'));
            amllib_autosave_vars.push('AlarmMutedOnTouchscreen');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'nosensecal1') {
            set_value('LN2_1_CalibrationMode', 3);
            amllib_autosave_vars.push('LN2_1_CalibrationMode');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'nosensecal2') {
            set_value('LN2_2_CalibrationMode', 3);
            amllib_autosave_vars.push('LN2_2_CalibrationMode');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'ntp') {
            amllib_ntp_requested = true;
            aml_poll_now();
        }
		else if (subcommand == 'format') {
            amllib_format_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'reset_error') {
        }
        else if (subcommand == 'savecal') {
            var x = get_value('LN2_1_CalibrationMode');
            if (x == 1) {
                amllib_autosave_vars.push('LN2_1_OscMaxLevelPeriod');
                amllib_autosave_vars.push('LN2_1_OscMaxPeriodDate');
                amllib_autosave_vars.push('LN2_1_OscMaxPeriodTime');
            }
            else if (x == 2) {
                amllib_autosave_vars.push('LN2_1_OscMinLevelPeriod');
                amllib_autosave_vars.push('LN2_1_OscMinPeriodDate');
                amllib_autosave_vars.push('LN2_1_OscMinPeriodTime');
            }
            else if (x == 3) {
                amllib_autosave_vars.push('LN2_1_OscNoSensorPeriod');
                amllib_autosave_vars.push('LN2_1_OscNoSensorPeriodTime');
                amllib_autosave_vars.push('LN2_1_OscNoSensorPeriodDate');
            }
            set_value('LN2_1_CalibrationMode', 0);
            amllib_autosave_vars.push('LN2_1_CalibrationMode');

            x = get_value('LN2_2_CalibrationMode');
            if (x == 1) {
                amllib_autosave_vars.push('LN2_2_OscMaxLevelPeriod');
                amllib_autosave_vars.push('LN2_2_OscMaxPeriodDate');
                amllib_autosave_vars.push('LN2_2_OscMaxPeriodTime');
            }
            else if (x == 2) {
                amllib_autosave_vars.push('LN2_2_OscMinLevelPeriod');
                amllib_autosave_vars.push('LN2_2_OscMinPeriodDate');
                amllib_autosave_vars.push('LN2_2_OscMinPeriodTime');
            }
            else if (x == 3) {
                amllib_autosave_vars.push('LN2_2_OscNoSensorPeriod');
                amllib_autosave_vars.push('LN2_2_OscNoSensorPeriodTime');
                amllib_autosave_vars.push('LN2_2_OscNoSensorPeriodDate');
            }
            set_value('LN2_2_CalibrationMode', 0);
            amllib_autosave_vars.push('LN2_2_CalibrationMode');

            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'savenet') {
            // get_json_new.cgi should notice when network config
            // variables are being saved and call the helper program
            // to actually change the network configuration
            amllib_cancel_requested = false;
            amllib_save_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'savetime') {
        }
        else if (subcommand == 'savevars') {
            amllib_cancel_requested = false;
            amllib_save_requested = true;
            // cancel timer so that the write happens immediately
            aml_poll_now();
        }
        else if (subcommand == 'shutdown') {
            set_value('shutdown', 1);
            amllib_autosave_vars.push('shutdown');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'updatefilename0') {
            set_value('UpdateName', get_value('s_updatefilename0'));
            amllib_autosave_vars.push('UpdateName');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'updatefilename1') {
            set_value('UpdateName', get_value('s_updatefilename1'));
            amllib_autosave_vars.push('UpdateName');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'updatefilename2') {
            set_value('UpdateName', get_value('s_updatefilename2'));
            amllib_autosave_vars.push('UpdateName');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'updatefilename3') {
            set_value('UpdateName', get_value('s_updatefilename3'));
            amllib_autosave_vars.push('UpdateName');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
        else if (subcommand == 'updatefilename4') {
            set_value('UpdateName', get_value('s_updatefilename4'));
            amllib_autosave_vars.push('UpdateName');
            amllib_autosave_requested = true;
            aml_poll_now();
        }
    }
}
function aml_cursor(args, uid, generation) {
    // [ x, y, xincr, yincr ] in pixels
    var new_amllib_cursor = amllib_cursor;

    if (args[0] == '=' || args[0] == '+')
        new_amllib_cursor[0] = amllib_cursor[0];
    else
        new_amllib_cursor[0] = args[0];
    if (args[1] == '=' || args[1] == '+')
        new_amllib_cursor[1] = amllib_cursor[1];
    else
        new_amllib_cursor[1] = args[1];
    new_amllib_cursor[2] = args[2];
    new_amllib_cursor[3] = args[3];
    amllib_cursor = new_amllib_cursor;

    next_amllib_cursor = new_amllib_cursor;
    if (args[0] == '+')
        next_amllib_cursor[0] = amllib_cursor[0] + amllib_cursor[2];
    if (args[1] == '+')
        next_amllib_cursor[0] = amllib_cursor[1] + amllib_cursor[3];
}

function aml_format(args, uid, generation) {
    // Arguably defined symbols should be maintained separately.  but
    // when defined symbols appear in expressions they're evaluated
    // just like variables... EXCEPT that doing a define doesn't set 
    // the modified bit.  So you can't use define to change the values
    // of shmem vars on the 17xx.
    //
    // Are we having FUN yet?
    var name = args[0];
	var format = args[1];

//    if (!(name in amllib_vars))
//        amllib_vars[name] = amlvar(name);
//    amllib_vars[name].current_value = args[1];
//    amllib_vars[name].cancel_value = args[1];
//    amllib_vars[name].initialized = true;
}

function aml_define(args, uid, generation) {
    // Arguably defined symbols should be maintained separately.  but
    // when defined symbols appear in expressions they're evaluated
    // just like variables... EXCEPT that doing a define doesn't set 
    // the modified bit.  So you can't use define to change the values
    // of shmem vars on the 17xx.
    //
    // Are we having FUN yet?
    var name = args[0].toLowerCase();

    if (!(name in amllib_vars))
        amllib_vars[name] = amlvar(name);
    amllib_vars[name].current_value = args[1];
    amllib_vars[name].cancel_value = args[1];
    amllib_vars[name].initialized = true;
}

function aml_display_text(args, uid, generation) {
    // args
    // 0    string to display
    // 1    fontsize (0..100 .. percentage of height)
    // 2    color
    // 3    x
    // 4    y
    // 5    left/center/right
    

    if (!(uid in amllib_objects)) {
        var t = document.createElement('div');
        var text = document.createTextNode(args[0]);

        t.id = 'text_' + uid;
        t.style.verticalAlign = 'text-bottom';
        t.style.fontSize = font_size(args[1]);
        t.style.color = makergb(args[2]);
        t.style.display = 'none'; // don't draw yet
        if ('border' in amllib_options)
            t.style.border = amllib_options.border;
        if (args.length > 5) {
            if (args[5] == "left") {
                t.style.textAlign = args[5];
                t.style.left = args[3] + "%";
            }
            else if (args[5] == "right") {
                // XXX not sure what this actually means.
                //     does the y parameter then specify the right side of the text?
                //     if so, it's going to require some special case handling
                t.style.textAlign = args[5];
                t.style.right = args[3] + "%";
            }
            else if (args[5] == "center") {
                // XXX not sure what this means and cairo code doesn't
                //     implement this yet, but I'm thinking it's horizontally
                //     centered around the supplied x coordinate.  So will
                //     we need to make width wide enough to contain the text,
                //     then set the left style attribute to suit?
                t.style.textAlign = args[5];
            }
        }
        else {
            // left is the default if not specified
            t.style.textAlign = "left";
            t.style.left = args[3] + "%";
        }
        t.appendChild(text);
        container.appendChild(t);

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].object = t;
        amllib_objects[uid].type = 'display-text';
        amllib_objects[uid].draw = aml_display_text_draw;
        amllib_objects[uid].hide = aml_display_text_hide;
    }
    else {
        t = amllib_objects[uid].object;
        amllib_objects[uid].generation = generation;
    }

    get_cursor ();
    t.style.position = 'absolute';
    y = y_percent(args[4]);
    // t.style.top = y + "%";
    t.style.bottom = ((100.0 - y) - bottom_fudge(args[1])) + '%';
}
function aml_display_text_draw(uid) {
    var t = amllib_objects[uid].object;

    t.style.display = 'block';
}
function aml_display_text_hide(uid) {
    var t = amllib_objects[uid].object;

    t.style.display = 'none';
}
function aml_display_var(args, uid, generation) {
    // args
    // 0    name of variable to display
    // 1    fontsize (% of height)
    // 2    color
    // 3    x
    // 4    y

    if (!(uid in amllib_objects)) {
        var t = document.createElement('div');
        var text = document.createTextNode(get_value(args[0]));

        t.id = 'var_' + args[0];
        t.style.verticalAlign = 'text-bottom';
        t.style.fontSize = font_size(args[1]);
        t.style.color = makergb(args[2]);
        if ('border' in amllib_options)
            t.style.border = amllib_options.border;
        t.appendChild(text);
        t.style.display = 'none';
        container.appendChild(t);

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].object = t;
        amllib_objects[uid].type = 'display-var';
        amllib_objects[uid].variable = args[0];
        amllib_objects[uid].y = args[3];
        amllib_objects[uid].draw = aml_display_var_draw;
        amllib_objects[uid].hide = aml_display_var_hide;

        aml_add_var(args[0], false);
    }
    else {
        t = amllib_objects[uid].object;
        amllib_objects[uid].generation = generation;
    }

    get_cursor ();
    t.style.position = 'absolute';
    t.style.left = args[3] + "%";
    y = y_percent(args[4]);
    t.style.bottom = ((100 - y) - bottom_fudge(args[1])) + '%';
}
function aml_display_var_draw (uid) {
    var t = amllib_objects[uid].object;
    var variable = amllib_objects[uid].variable;

    t.textContent = get_value(variable);
    t.style.display = 'block';
}
function aml_display_var_hide (uid) {
    var t = amllib_objects[uid].object;

    t.style.display = 'none';
}
function aml_execute(args, uid, generation) {
    uid = find_object_uid (e);
//	window.location.href = 'index.cgi?page=' + linkname;
//    aml_poll_now();
}

function aml_font(args, uid, generation) {
    // XXX should this set the global font, or does it set the font to be used when
    //     creating new document elements?   they're almost but not quite the same.
    container.style.fontFamily = args[0];
}
function aml_graph(args, uid, generation) {
    // arg
    // 0    background color
    // 1	gridlines color
    // 2	ln2_1 color
    // 3	ln2_2 color
    // 4    lhe_color
    // 5    width
    // 6    height
    // 7    x
    // 8    y
    //
    // Note: compiler has noticed that the graph() function was called
    // and included the <SCRIPT> tags needed to read in the js support
    // for that function.
    if (!(uid in amllib_objects)) {
        // <div id="cg1">
        // <canvas id='chartie'></canvas>
        // </div>
        var t = document.createElement('div');
        var c = document.createElement('canvas');

        amllib_graph_called = true;
        t.id = 'cg1';
        // t.style.backgroundColor = makergb(args[0]);
        t.style.backgroundColor = 'black';
        t.style.color = makergb(args[0]);
        t.style.width = args[5] + '%';
        t.style.height = args[6] + '%';
        t.style.left = args[7] + '%';
        t.style.top = args[8] + '%';
        t.style.position = 'absolute';
        c.id = 'chartie';
        c.style.width = '110%';
        c.style.height = '100%';
        c.style.marginLeft = '-10%';
		
        t.appendChild(c);
        container.appendChild(t);

        amllib_objects[uid] = {};
        amllib_objects[uid].object = t;
        amllib_objects[uid].canvas = c;
        amllib_objects[uid].gridlinesColor = makergb(args[1]);
        amllib_objects[uid].ln2_1_Color = makergb(args[2]);
        amllib_objects[uid].ln2_2_Color = makergb(args[3]);
        amllib_objects[uid].lhe_Color = makergb(args[4]);
		graph_line = new RGraph.Line(	{
			id: 'chartie',
			data: [[], []],
			options: {
				numxticks: 10,
				tickmarks: '',
				backgroundGridAutofitNumvlines: 10,
				backgroundGridColor: '#070',
				
				//	colors: ['#0f0', '#00f'],
				// colors: ['#9ff', '#ff6', '#2f0'],
                colors: ami_model == '1700' ?
                    [makergb(args[2]), makergb(args[4])] : // ln2_1, lhe
                    [makergb(args[2]), makergb(args[3])],  // ln2_1, ln2_2
				
				textColor: '#3ee',
				shadow: false,
				shadowColor:'#fff',
				
				gutterLeft:   35,
				gutterRight:  5,
				gutterTop:    5,
				gutterBottom: 5,
                xaxisTickmarks: false,
				ylabelsSpecific: [''],
                yaxisLabelsSize: 0.1,
                yaxisPosition: 'right',
                yaxisTickmarks: false,
                marginLeft: 0,
                marginRight: 0,
				axisColor: '#070',
				ymax: 100,
				outofboundsClip: true,
				// textAccessible: true
                textAccessible: false
			}
		});
        amlvar('s_hst_label');
        amlvar('s_hst_btime');
        amlvar('s_hst_bdate');
        amlvar('s_hst_etime');
        amlvar('s_hst_edate');
    }
}


gtimeperdiv=[
	           30,
	         1*60,                // minutes per div
	         2*60,
	         5*60,
	        10*60,
		  
            30*60,
	      1*60*60,                // hours per div
	      3*60*60,
		  6*60*60,
         12*60*60,

	     24*60*60,
       7*24*60*60,
(365/12)*24*60*60,
];

var glabels=[
	"30 secs/div",
	"1 min/div",
	"2 mins/div",
	"5 mins/div",
	"10 mins/div",
	
	"30 mins/div",
	"1 hour/div",
	"3 hours/div",
	"6 hours/div",
	"12 hours/div",
	
	"1 day/div",
	"1 week/div",
	"1 month/div"
 ];



// XXX probably should have made this one work like all of the other _draw
//     functions but was trying to crib from the old .ml2 code -km
function aml_graph_draw (jsonGraphData, bt, et) {
	var i;
	var x;
	var od= new Date();
	var db = new Date(od.getTime() - bt);
	var de = new Date(od.getTime() - et);
	
    // update the variables used to display graph legends
    // can't use set_value() to do these because that would change
    // s_var_modified (though maybe it shouldn't if editable is false)
    set_value_u('s_hst_label', glabels[gzoomi]);
    set_value_u('s_hst_bdate',
                db.getFullYear() + "/" + 
		        ("0" +(db.getMonth()+1)).slice(-2) + "/" +
		        ("0" + db.getDate()).slice(-2));
    set_value_u('s_hst_btime',
                ("0" + db.getHours()).slice(-2) + ":" + 
		        ("0" + db.getMinutes()).slice(-2) + ":" +
		        ("0" + db.getSeconds()).slice(-2));
    set_value_u('s_hst_edate',
                de.getFullYear() + "/" + 
		        ("0" +(de.getMonth()+1)).slice(-2) + "/" +
		        ("0" + de.getDate()).slice(-2));
    set_value_u('s_hst_etime',
                ("0" + de.getHours()).slice(-2) + ":" + 
		        ("0" + de.getMinutes()).slice(-2) + ":" +
		        ("0" + de.getSeconds()).slice(-2));
    
	graph_line.original_data[0]=jsonGraphData[0];
	graph_line.original_data[1]=jsonGraphData[1];
	// graph_line.original_data[2]=jsonGraphData[2];
    
	RGraph.clear(graph_line.canvas);
	graph_line.draw();
	// if(gprocessing>0)
	//     gprocessing--;
 }
function aml_graph_update_request(request) {
    if (amllib_graph_called) {
        request['rgraph'] = {
            'n2_1_show': gshowN2_1,
            'n2_2_show': gshowN2_2,
            'he_show': gshowHe, // XXX not yet implement in get_json_new.cgi   // xxxx now it is, bf apr 28 2020
            'graphtime': gposition,
            'horzscale': gtimeperdiv[gzoomi] * 10/MAXGRAPHDATAPOINTS
        };
    }
}
function aml_hide_objects(generation) {
    for (var uid in amllib_objects)
        if (amllib_objects[uid].generation < generation)
            if ('hide' in amllib_objects[uid])
                amllib_objects[uid].hide(uid);
}
function aml_init() {           // note: MUST BE PRESENT (compiler expects it)
    // build initial list of variables to request, and initialize them in
    // amllib_vars
    amllib_requests = [];
    for (var i in vars) {
        var v = vars[i];
        var id;
        var lcid;

        // if variable name ends in '#', strip off the '#' for the requests
        // array but also set the local_referenced flag

        if (v.length > 1 && v[v.length - 1] == '#') {
            id = v.substr(0, v.length-1);
            lcid = id.toLowerCase();
            if (amllib_requests.indexOf (id) < 0)
                amllib_requests.push(id);
            if (!(lcid in amllib_vars))
                amllib_vars[lcid] = amlvar(id);
            amllib_vars[lcid].local_referneced = true;
        }
        else {
            id = v;
            lcid = id.toLowerCase();
            if (amllib_requests.indexOf (id) < 0)
                amllib_requests.push(id);
            // don't clear local_referenced if already set
            if (!(lcid in amllib_vars))
                amllib_vars[lcid] = amlvar(id);
            if (! ('local_referenced' in amllib_vars[lcid]))
                amllib_vars[lcid].local_referenced = false;
        }
    }
    // initialize autofill colors
    amllib_vars['c_autofill'] = amlvar('c_autofill');
    amllib_vars['c_autofill'].initialized = true;
    amllib_vars['c_autofill1'] = amlvar('c_autofill1');
    amllib_vars['c_autofill1'].initialized = true;
    amllib_vars['c_autofill2'] = amlvar('c_autofill2');
    amllib_vars['c_autofill2'].initialized = true;
    // request variables from server and redraw as needed
    // XXX maybe fold this in?
    aml_request_json_init(amllib_requests);
}
function aml_interval() {
    var now = Date.now();
    
    if (amllib_request_time != null) {
        // There's already an XMLHttpRequest outstanding, don't issue another
        // until this one finishes some way or another.
        //
        // XXX do something to clean up requests that never finish
        ;
    }
    else if (amllib_last_interval == null) {
        // interval has not been set yet
        amllib_last_interval = now;
        aml_poll();
    }
    else if ((now - amllib_last_interval) > amllib_poll_interval) {
        amllib_last_interval = now;
        aml_poll();
    }
    else {
        ;
    }
}
function aml_keep_aspect_ratio(id, w, h) {
    var arDiv = document.getElementById (id);

    if ((window.innerWidth / window.innerHeight) > (w / h)) {
        // window is wider than aspect ratio
        arDiv.style.fontSize = window.innerHeight / 10 + "px";
        arDiv.style.height = window.innerHeight;
        arDiv.style.width = ((window.innerHeight * w) / h) << 0 + "px";
        // horizontally center at top of window
        arDiv.style.left = (window.innerWidth - (((window.innerHeight * w) / h) << 0)) / 2;
        arDiv.style.top = 0;
    }
    else if ((window.innerWidth / window.innerHeight) < (w / h)) {
        // window is taller than aspect ratio
        arDiv.style.fontSize = ((window.innerWidth * h) / w) / 10.0 + "px";
        arDiv.style.width = window.innerWidth;
        arDiv.style.height = ((window.innerWidth * h) / w) << 0 + "px";
        // place at top left
        arDiv.style.left = 0;
        arDiv.style.top = 0;
    }

// this should make the container centered, but the marginTop/Left attributes seemed to be overwritten to 0	
//	arDiv.style.left = "50%";
//	arDiv.style.top = "50%";
//	arDiv.style.marginTop = -arDiv.style.width/2 + "px";
//	arDiv.style.marginLeft = -arDiv.style.height/2 + "px";

	// now that we've resized, make container visible
    arDiv.style.visibility = "visible";
}
function aml_link(args, uid, generation) {
    // args
    // 0    label
    // 1    linkfilename
    // 2    fontsize
    // 3    en_labelcolor
    // 4    dis_labelcolor
    // 5    en_buttoncolor
    // 6    dis_buttoncolor
    // 7    x
    // 8    y


    if (!(uid in amllib_objects)) {
        var t = document.createElement('div');
        var textnode = document.createTextNode(args[0])

        t.id = 'link_' + args[0];
        t.style.verticalAlign = 'text-bottom';
        t.style.fontSize = font_size(args[2]);
        t.style.color = makergb(args[3]);
        t.style.backgroundColor = makergb(args[5]);
        if ('border' in amllib_options)
            t.style.border = amllib_options.border;
        else {
            t.style.border = '2px';
            t.style.borderRadius = '0.3em';
        }
        t.style.boxShadow = '0 1px 2px rgba(0,0,0,0.2)';
        t.style.paddingTop = '0.05em';
        t.style.paddingBottom = '0.05em';
        t.style.paddingLeft = '0.25em';
        t.style.paddingRight = '0.25em';
        t.style.cursor = 'pointer';
        t.style.outline = 'none';
        t.style.textDecoration = 'none';
        t.style.textShadow = '0 1px 1px rgba(0,0,0,0.3)';
        t.appendChild(textnode);
        t.onclick = aml_link_onclick;
        t.style.display = 'none' // don't draw yet
        container.appendChild(t);

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].linkfilename = args[1];
        amllib_objects[uid].object = t;
        amllib_objects[uid].type = 'link';
        amllib_objects[uid].draw = aml_link_draw;
        amllib_objects[uid].hide = aml_link_hide;
    }
    else {
        t = amllib_objects[uid].object;
        amllib_objects[uid].generation = generation;
    }

    get_cursor ();
    t.style.position = 'absolute';
    t.style.left = args[7] + "%";
    y = y_percent(args[8]);
    t.style.bottom = ((100 - y) - bottom_fudge(args[2])) + "%";
}
function aml_link_draw (uid) {
    var t = amllib_objects[uid].object;

    t.style.display = 'block';
}
function aml_link_hide (uid) {
    var t = amllib_objects[uid].object;
    
    t.style.display = 'none';
}
function aml_link_onclick(e) {
    uid = find_object_uid (e);
    if (uid in amllib_objects && 'linkfilename' in amllib_objects[uid]) {
        linkname = amllib_objects[uid].linkfilename;
        if (linkname.endsWith('.aml'))
            linkname = linkname.substring(0, linkname.length-4);
        window.location.href = 'index.cgi?page=' + linkname;
    }
}
function aml_list_files_from_dir (args, uid, generation) {
    s_updatedir = args[0];
    if (!(uid in amllib_objects)) {
        amllib_objects[uid] = {};
    }
}
function aml_load_script (url, callback) {
    var script = document.createElement("script")
    script.type = "text/javascript";

    if (script.readyState){  //IE
        script.onreadystatechange = function(){
            if (script.readyState == "loaded" ||
                    script.readyState == "complete"){
                script.onreadystatechange = null;
                callback();
            }
        };
    } else {  //Others
        script.onload = function(){
            callback();
        };
    }
    script.src = url;
    document.getElementsByTagName("head")[0].appendChild(script);
}
function aml_loop () {          // note: MUST BE HERE - compiler expects it
    // originally this was a call to setInterval and it might yet be
    // one again someday but for now letting aml_poll manage the timeout
    // seems to make more sense
    setInterval(aml_interval, amllib_timer_interval);
    // aml_poll();
}
function aml_numberedit_var(args, uid, generation) {
    // like textedit_var except that a numeric keyboard pops up
    // when a touchscreen is used
    
    // args
    // 0    variable name
    // 1    savemode
    // 2    fontsize
    // 3    color
    // 4    x
    // 5    y
    // 6    nchars

    var variable = args[0];
    var savemode = args[1];
    var fontsize = args[2];
    var color = args[3];
    var x = args[4];
    var y = args[5];
    var nchars = args[6];       // XXX

    if (!(uid in amllib_objects)) {
        // create element and add it to document
        var inputnode = document.createElement('input');

        inputnode.id = 'numberedit_' + args[0];
        inputnode.type = 'text';
        // inputnode.size = nchars;         // XXX set width instead?
        inputnode.style.width = nchars + 'ch';
        inputnode.style.verticalAlign = 'text-bottom';
        inputnode.style.fontSize = font_size(args[2]);
        // inputnode.style.color = makergb(args[3]);
        inputnode.style.color = 'black';
        inputnode.style.backgroundColor = makergb(0xffffff);
        if ('border' in amllib_options)
            inputnode.style.border = amllib_options.border;
        else {
            inputnode.style.border = '2px';
            inputnode.style.borderRadius = '0.25em';
            inputnode.style.boxShadow = '0 1px 2px rgba(0,0,0,0.2)';
        }
        // inputnode.style.paddingTop = '0.25em';
        // inputnode.style.paddingBottom = '0.0em';
        // inputnode.style.paddingLeft = '0.25em';
        // inputnode.style.paddingRight = '0.25em';
        inputnode.style.paddingTop = '0.0em';
        inputnode.style.paddingBottom = '0.0em';
        inputnode.style.paddingLeft = '0.0em';
        inputnode.style.paddingRight = '0.0em';
        inputnode.style.textAlign = 'left';
        inputnode.style.cursor = 'pointer';
        inputnode.style.outline = 'none';
        inputnode.style.textDecoration = 'none';
        inputnode.style.textShadow = '0 1px 1px rgba(0,0,0,0.3)';
        inputnode.style.display = 'none'; // don't draw yet
        container.appendChild (inputnode);
        inputnode.onkeyup = aml_numberedit_var_change;
        inputnode.onchange = aml_numberedit_var_change;

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].id = inputnode.id;
        amllib_objects[uid].object = inputnode;
        amllib_objects[uid].type = 'numberedit-var';
        amllib_objects[uid].variable = args[0];
        amllib_objects[uid].draw = aml_numberedit_var_draw;
        amllib_objects[uid].hide = aml_numberedit_var_hide;

        aml_add_var(args[0], true);
    }
    else {
        inputnode = amllib_objects[uid].object;
        amllib_objects[uid].generation = generation;
    }

    // allow repositioning on subsequent calls to aml_numberedit_var()
    get_cursor ();
    inputnode.style.position = 'absolute';
    inputnode.style.left = args[4] + '%';
    y = y_percent(args[5]);
    inputnode.style.bottom = ((100.0 - y) - bottom_fudge(args[2])) + "%";

    inputnode.value = get_value(variable);
}
function aml_numberedit_var_change() {
    var uid = find_uid_by_id (this.id);

    if (uid >= 0) {
        var varname = amllib_objects[uid].variable;
        var object = amllib_objects[uid].object;
        var value = get_value(varname);

        if (value != object.value) {
            set_value(varname, object.value);
        }
    }
}
function aml_numberedit_var_draw(uid) {
    var object = amllib_objects[uid].object;
    var variable = amllib_objects[uid].variable;

    object.value = get_value(variable);
    object.style.display = 'inline';
}
function aml_numberedit_var_hide(uid) {
    var object = amllib_objects[uid].object;

    object.style.display = 'none';
}
// see notes prefacing aml_request_json_async, below
// behavior of this routine is driven by several variables:
// amllib_ntp_requested - button with ntp subcommand has been pressed
// amllib_installupdate_requested - install button has been pressed
// amllib_factoryreset_requested - factory reset button has been pressed
// amllib_createfactoryreset_requested - create factory reset button has 
//     been pressed
// amllib_cancel_requested - cancel button has been pressed
// amllib_save_requested - save button has been pressed
// amllib_autosave_requested - some toggle with autosave mode has been pressed
// amllib_writethrough - treat amllib_vars as a write-through cache so that
//     changes get written to the 17xx at the next poll.  otherwise only write
//     to shmem when the user hits save.
//
// also amllib_goto_link is used by callers of this routine to tell
// aml_request_json_async to go to another page after the next poll is
// completed.
//
// >>> The overall strategy is to only have one outstanding request to
//     a server at any one time, so there is at all times one locus of
//     control.  This makes things a lot simpler as there is no need
//     for mutual exclusion.  Also, the requests to the server are
//     always triggered by a single timer which always calls aml_poll()
//     as its callback.
//
function aml_poll() {
    if (amllib_factoryreset_requested) {
        amllib_factoryreset_requested = false;
        aml_request_json_async("factoryreset", {}, false, false,
                               amllib_poll_interval);
    }
    else if (amllib_createfactoryreset_requested) {
        amllib_createfactoryreset_requested = false;
        aml_request_json_async("createfactoryreset", {}, false, false,
                               amllib_poll_interval);
    }
    else if (amllib_installupdate_requested) {
        amllib_installupdate_requested = false;
        aml_request_json_async("installupdate", {}, false, false,
                               amllib_poll_interval);
    }
    else if (amllib_ntp_requested) {
        amllib_ntp_requested = false;
        aml_request_json_async("ntp", {}, false, false, amllib_poll_interval);
    }
    else if (amllib_autofill1statechange_requested) {
        amllib_autofill1statechange_requested = false;
       aml_request_json_async("af1statechg", {}, false, false, amllib_poll_interval);
    }
    else if (amllib_autofill2statechange_requested) {
        amllib_autofill2statechange_requested = false;
       aml_request_json_async("af2statechg", {}, false, false, amllib_poll_interval);
    }
    else if (amllib_cancel_requested) {
        amllib_cancel_requested = false;
        aml_request_json_async("cancel", {}, true, true, amllib_poll_interval);
    }
    else if (amllib_save_requested) {
        // save all editable variables (even if unmodified)
        // (that way all of the vars on screen will be updated, for consistency)
        var updates = {};

        for (var p in amllib_vars) {
            if (amllib_vars[p].editable) {
                updates[amllib_vars[p].shmem_key] = amllib_vars[p].current_value;
            }
        }
        aml_request_json_async("save", updates, true, true, amllib_poll_interval);
    }
    else if (amllib_autosave_requested) {
        // save only autosave variables
		var updates = {};

		for (var i in amllib_autosave_vars) {
			var lcvarname = amllib_autosave_vars[i].toLowerCase();
            updates[amllib_vars[lcvarname].shmem_key] = 
                amllib_vars[lcvarname].current_value;
        }
        amllib_autosave_vars = [];
        amllib_autosave_requested = false;
        aml_request_json_async("autosave", updates, false, false, 
                               amllib_poll_interval);
    }
    else {
        if (amllib_writethrough) {
            // write (only) modified variables to 17xx but don't save them
            var updates = {};

            for (var p in amllib_vars) {
                if (amllib_vars[p].editable && amllib_vars[p].modified) {
                    updates[amllib_vars[p].shmem_key] = amllib_vars[p].current_value;
                }
            }
            aml_request_json_async("writethrough", updates, false, false, 
                                   amllib_poll_interval);
        }
        else {
            // don't write any variables to 17xx on a normal (non-save) poll -
            // just poll for changes on the 17xx
            aml_request_json_async("", {}, false, false, amllib_poll_interval);
        }
    }
}
function aml_poll_now() {
    // cancel any pending timer and reset timer to trigger poll immediately

    // XXX
    // if (amllib_timer != null)
    //     clearTimeout (amllib_timer);
    // amllib_timer = setTimeout(aml_poll, 1);

    // set amllib_last_interval to null so that the next interval
    // timer callback to aml_interval() will immediately send a
    // request
    amllib_last_interval = null;
}
function aml_pop_include() {
    amllib_includes.pop();
}
function aml_push_include(args) {
    amllib_includes.push(args);
}
function aml_readtextfile(args, uid, generation) {
    // args
    // 0    filename
    // 1    font size
    // 2    color
    // 3    x
    // 4    y
    if (!(uid in amllib_objects)) {
        var t = document.createElement('div');
        var text = document.createTextNode('');

        t.id = 'textfile' + uid;
        t.style.verticalAlign = 'text-bottom';
        t.style.fontSize = font_size(args[1]);
        t.style.color = makergb(args[2]);
        if ('border' in amllib_options)
            t.style.border = amllib_options.border;
        t.appendChild(text);
        t.style.display = 'none'
        container.appendChild(t);

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].object = t;
        amllib_objects[uid].type = 'textfile';
        amllib_objects[uid].variable = args[0];
        amllib_objects[uid].x = args[3];
        amllib_objects[uid].y = args[4];
        amllib_objects[uid].draw = aml_readtextfile_draw;
        amllib_objects[uid].hide = aml_readtextfile_hide;

        aml_add_var(args[0], false);
    }
    else {
        t = amllib_objects[uid].object;
        amllib_objects[uid].generation = generation;
    }

    get_cursor();
    t.style.position = 'absolute';
    t.style.left = args[3] + '%';
    y = y_percent(args[4]);
    t.style.top = '30%';
    // t.style.bottom == ((100 - y) - bottom_fudge(args[1])) + '%';
}
function aml_readtextfile_draw(uid) {
    var t = amllib_objects[uid].object;
    var variable = amllib_objects[uid].variable;

    t.innerHTML = get_value(variable);
    t.style.display = 'block';
}
function aml_readtextfile_hide(uid) {
    var t = amllib_objects[uid].object;
    
    t.style.display = 'none';
}
function aml_really_draw_page(generation) {
    aml_update_fill_colors();
    aml_draw_page(generation);
}
function aml_request_json_init(amllib_requests) {
    // initial request of shmem vars - called by aml_init()
    var jsonhttp;
    var remote_modified_flag = false;

    // The first time we draw the page, we don't know all of the
    // variables we need because (a) the compiler doesn't know about
    // the individual arguments of each AML function called, and (b)
    // some of the AML functions that draw things derive the variable
    // names of the values that they need from their arguments.  
    // 
    // However every object that is called will add any variables it
    // needs to the amilib_requests[] list.  So on subsequent polls of
    // the server the page will get the variables needed to draw the
    // current version of the page.

    if (window.XMLHttpRequest)
        jsonhttp = new XMLHttpRequest();
    else
        jsonhttp = new ActiveXObject ("Microsoft.XMLHTTP");
    jsonhttp.open('POST', server_url, false);
    jsonhttp.setRequestHeader('Content-type', 'application/json')
    jsonhttp.send(JSON.stringify({
        'requests': amllib_requests,
        'updates': {}
    }));
    jsonResponse = JSON.parse(jsonhttp.responseText);
    for (var p in jsonResponse) {
        var lcp = p.toLowerCase();

        if (lcp == 'status' || lcp == 'error')
            continue;
        else if (lcp == '$modified') {
            remote_modified_flag = jsonResponse[p];
            continue;
        }
        if (! (lcp in amllib_vars)){
            // shouldn't happen, but don't pop up window unless debugging
            //alert("variable " + lcp + "not already in amllib_vars");
            amllib_vars[lcp] = amlvar(p);
        }
        amllib_vars[lcp].current_value = jsonResponse[p];
        amllib_vars[lcp].cancel_value = jsonResponse[p];
        amllib_vars[lcp].initialized = true;
    }
    s_var_modified = s_local_var_modified || remote_modified_flag;
    aml_really_draw_page(0);
    aml_show_objects (0);
    jsonhttp.open('POST', server_url, false);
    jsonhttp.setRequestHeader('Content-type', 'application/json')
    jsonhttp.send(JSON.stringify({
        'requests': amllib_requests,
        'updates': {}
    }));
    jsonResponse = JSON.parse(jsonhttp.responseText);
    for (var p in jsonResponse) {
        var lcp = p.toLowerCase();

        if (lcp == 'status' || lcp == 'error' || lcp == '$modified')
            continue;
        if (! (lcp in amllib_vars)){
            // shouldn't happen, but don't pop up window unless debugging
            // alert("variable " + lcp + "not already in amllib_vars");
            amllib_vars[lcp] = amlvar(p);
        }
        amllib_vars[lcp].current_value = jsonResponse[p];
        amllib_vars[lcp].cancel_value = jsonResponse[p];
        amllib_vars[lcp].initialized = true;
    }
    aml_really_draw_page(1);
    aml_hide_objects(1);
    aml_show_objects(1);
    generation = 2;
}
// XXX the interface to this function is a mess.  There are at least 3 different
//     things that control how the function acts:
//     1. mode variable
//     2. updates actual parameter supplied by aml_poll() which is built
//        differently for different cases
//     3. s_local_var_modified
//     and amllib_poll_interval is always the same at least at the moment.
//
//     This could/should probably be cleaned up a lot as doing the
//     case analysis for what this routine should do in each case is a
//     pain.  Offhand I'm thinking switch as much as possible based on
//     the mode parameter, get rid of parameters that can be determined
//     from the mode parameter + global vars.   -KM   2020/03/19
function aml_request_json_async(
    mode, updates, reset_modified, reset_save_requested, next_poll) {
    var jsonhttp;
    var remote_modified_flag = false;

    if (window.XMLHttpRequest)
        jsonhttp = new XMLHttpRequest();
    else
        jsonhttp = new ActiveXObject ("Microsoft.XMLHTTP");
    jsonhttp.open('POST', server_url, true);
    jsonhttp.setRequestHeader('Content-type', 'application/json')
    jsonhttp.timeout = 5000;     // milliseconds
    // jsonhttp.ontimeout = function () {
    //    // XXX if timeouts persist, change display to gray
    //    //     (but still reset timer)
    //    if (next_poll > 0) {
    //        clearTimeout (amllib_timer);
    //        amllib_timer = setTimeout (aml_poll, next_poll);
    //    }
    // };
    jsonhttp.onreadystatechange = function () {
        if (jsonhttp.readyState == 4 && jsonhttp.status == 200) {
            var jsonResponse;

            amllib_request_time = null;
            if (jsonhttp.responseText.length == 0) {
                // for whatever reason get_json_http.cgi returned no
                // output.  maybe the user shut down the system or
                // changed the system time before the cgi program
                // finished its output?  at any rate, don't try to
                // process the response since there was none.
                return;
            }
            // another thing that happens is that jsonhttp.responseText
            // contains the HTTP response headers before the actual JSON
            // I am guessing that the response was truncated for some
            // reason.  moving the calls to helper functions to the end
            // of get_json_new.c, after the JSON has been generated and
            // stdout closed, seemed to address the problem.

            try {
                jsonResponse = JSON.parse(jsonhttp.responseText);
            } catch (error) {
                alert(error);   // XXX leave enabled for now

                // XXX malformed JSON output from get_json_new.cgi
                //     this "should not happen" but apparently it
                //     sometimes does.  right thing to do is probably
                //     something like retrying the request at the
                //     normal polling interval, but the way the code
                //     is currently structured, this is hard to do,
                //     because we have already reset some of the flags
                //     that aml_poll() uses to decide what request to
                //     make.  What's here for now is hopefully better
                //     than nothing but will cause command() button
                //     presses to be unrecognized.
                //
                //     also, ideally there would be some way to at
                //     least log these anomalies.

                // if (next_poll > 0) {
                //     clearTimeout(amllib_timer);
                //     amllib_timer = setTimeout (aml_poll, next_poll);
                // }
                return;
            }

            if (jsonResponse.status == 'ok') {
                // server said "ok" so update the local variables list
                // from the list of variables that the server returned...

                // Don't always reset amllib_save_requested to false
                // because if we're doing an autosave toggle we might
                // still have some other vars needing an explicit
                // SAVE.
                if (reset_save_requested)
                    amllib_save_requested = false;

                // Don't reset s_local_var_modified unless
                // specifically requested because sometimes we're just
                // saving specific variables instead of saving
                // everything that is editable.
                if (reset_modified)
                    s_local_var_modified = 0;

                // reset modified bit on vars that have been written
                // to shared memory on the 17xx
                for (var k in updates) {
                    var lck = k.toLowerCase();
                    if (lck in amllib_vars) {
                        amllib_vars[lck].modified = false;
                    }
                }
                // now update the local copy of every variable received
                // from the 17xx
                for (var p in jsonResponse) {
                    var lcp = p.toLowerCase();
                        
                    if (lcp == 'status' || lcp == 'error') {
                        // skip status and error messages for now but we
                        // might be able to use them later
                        continue;
                    }
                    else if (lcp == '$modified') {
                        remote_modified_flag = jsonResponse[p];
                        continue;
                    }
                    else if (lcp == 'rgraph') {
                        if (amllib_graph_called) {
                            if (ami_model == '1700') {
                                aml_graph_draw(
                                    [jsonResponse['rgraph']['n2_1'],
                                     jsonResponse['rgraph']['he']],
                                    gposition * 1000,
                                    (gposition + gtimeperdiv[gzoomi]*10)*1000);
                            }
                            else if (ami_model == '1720') {
                                aml_graph_draw(
                                    [jsonResponse['rgraph']['n2_1'],
                                     jsonResponse['rgraph']['n2_2']],
                                    gposition * 1000,
                                    (gposition + gtimeperdiv[gzoomi]*10)*1000);
                            }
                        }
                    }
                    else if (lcp == 's_hst_label' || lcp == 's_hst_btime' ||
                             lcp == 's_hst_bdate' || lcp == 's_hst_etime' ||
                             lcp == 's_hst_edate') {
                        // arrgh!  - said the legendary black beast
                        // (as quoted by Joseph of Aramathea)
                        //
                        // skip these because they're computed locally
                        continue;
                    }
                    if (! (lcp in amllib_vars)) {
                        // create local copy of the variable if we
                        // don't have it already
                        amllib_vars[lcp] = amlvar(p);
                        amllib_vars[lcp].current_value = jsonResponse[p];
                        amllib_vars[lcp].cancel_value = jsonResponse[p];
                        amllib_vars[lcp].initialized = true;
                    }
                    if (jsonResponse[p] == 'undefined') {
                        // ignore these, don't overwrite local copies
                        // this mostly happens when we've set some variable
                        // from javascript that doesn't actually exist
                        // in shmem and isn't concocted in get_json_new.cgi
                        ;
                    }
                    else if (mode == 'save' || mode == 'cancel') {
                        // unconditionally update both save and cancel vars 
                        // from response
                        amllib_vars[lcp].current_value = jsonResponse[p];
                        amllib_vars[lcp].cancel_value = jsonResponse[p];
                    }
                    else if (mode == 'autosave') {
                        // don't update editable vars if local vars are modified
                        // (only useful if called with reset_modified==false)
                        if (s_local_var_modified == 0 || 
                            amllib_vars[lcp].editable == false) {
                            amllib_vars[lcp].current_value = jsonResponse[p];
                            amllib_vars[lcp].cancel_value = jsonResponse[p];
                        }
                    }
                    else {
                        // update current values if local vars aren't modified
                        if (s_local_var_modified == 0) {
                            amllib_vars[lcp].current_value = jsonResponse[p];
                        }
                    }
                    amllib_vars[lcp].initialized = true;
                }
                // if there's a goto link that's different from the current page, 
                // goto that page now
                if (amllib_goto_link != null) {
                    if (amllib_goto_link.endsWith('.aml'))
                        amllib_goto_link = 
                            amllib_goto_link.substring(0, amllib_goto_link.length-4);
                    // if we're linking to the same page, don't reload
                    if (amllib_goto_link != get_value('s_page'))
                        window.location.href = 'index.cgi?page=' + amllib_goto_link;
                }
                s_var_modified = s_local_var_modified || remote_modified_flag;
                generation = generation + 1;
                aml_really_draw_page (generation);
                aml_hide_objects (generation);
                aml_show_objects (generation);
                // if (next_poll > 0) {
                //     amllib_timer = setTimeout (aml_poll, next_poll);
                // }
            }
            else {
                // XXX status other than 'ok' returned from 17xx unit
                // if (next_poll > 0) {
                //     amllib_timer = setTimeout (aml_poll, next_poll);
                // }
                ;
            }
        }
        else if (jsonhttp.readyState == 4) {
            // XXX sometimes http status is 0 which supposedly
            //     means request is not complete, but not sure
            //     what that means on the server end
            // XXX still need to get rid of the alert() call
            if (jsonhttp.status != 0)
                alert("http status = " + jsonhttp.status);
            // if (next_poll > 0) {
            //    amllib_timer = setTimeout (aml_poll, next_poll);
        }
        else {
            // XXX some other XHR state change or status
        }
    };

    // ugly hack: if the aml file has called aml_list_files_from_dir
    // it has set s_updatedir, and if that's been done, add
    // s_updatedir to the updates so that we'll pass the directory
    // to get_json_new.cgi
    if (s_updatedir != null) {
        updates['s_updatedir'] = s_updatedir;
    }
    amllib_request_time = Date.now();
    if (mode == "autosave") {
        // save but we're only saving specific variables
        jsonhttp.send(JSON.stringify({'op': 'autosave',
									  'requests': amllib_requests,
                                      'updates': updates}));
    }
    else
	if (mode == "cancel") {
        // cancel (i.e. unsave) some modified vars on the 17xx,
        // but only those vars listed in amllib_cancel_vars

        var opvars = [];

        for (var p in amllib_cancel_vars) {
            opvars.push(p);
        }
        request = {'op': 'cancel',
                   'opvars': opvars,
                   'requests': amllib_requests,
                   'updates': {} };
        aml_graph_update_request(request);
        jsonhttp.send(JSON.stringify(request));
    }
    else if (mode == "createfactoryreset") {
        jsonhttp.send(JSON.stringify({'op': 'createfactoryreset',
                                      'requests': amllib_requests}));
    }
    else if (mode == "factoryreset") {
        jsonhttp.send(JSON.stringify({'op': 'factoryreset',
                                      'requests': amllib_requests}));
    }
    else if (mode == "installupdate") {
        jsonhttp.send(JSON.stringify({'op': 'installupdate',
                                      'requests': amllib_requests}));
    }
    else if (mode == "ntp") {
        jsonhttp.send(JSON.stringify({'op': 'ntp',
                                      'requests': amllib_requests}));
    }
    else if (mode == "af1statechg") {
        jsonhttp.send(JSON.stringify({'op': 'af1statechg',
                                      'requests': amllib_requests}));
    }
    else if (mode == "af2statechg") {
        jsonhttp.send(JSON.stringify({'op': 'af2statechg',
                                      'requests': amllib_requests}));
    }
    else if (mode == "save") {
        var opvars = [];

        for (var p in amllib_17xx_save_vars)
            opvars.push(p);
        request = {'op': 'save',
                   'opvars': opvars,
                   'requests': amllib_requests,
                   'updates': updates}
        aml_graph_update_request(request);
        jsonhttp.send(JSON.stringify(request));
    }
    // Note: aml_poll() passes different updates between the writethrough
    // and the normal mode.   Code here is the same for now for each case.
    else if (mode == "writethrough") {
        var opvars = [];

        for (var p in amllib_17xx_watch_vars)
            opvars.push(p);
        request = {'requests': amllib_requests,
                   'opvars': opvars,
                   'updates': updates};
        aml_graph_update_request(request);
        jsonhttp.send(JSON.stringify(request));
    }
    else {
        var opvars = [];

        for (var p in amllib_17xx_watch_vars)
            opvars.push(p);
        request = {'requests': amllib_requests,
                   'opvars': opvars,
                   'updates': updates};
        aml_graph_update_request(request);
        jsonhttp.send(JSON.stringify(request));
    }
}
function aml_save() {
    amllib_cancel_requested = false;
    amllib_save_requested = true;
    // trigger an immediate save
    aml_poll_now();
}
function aml_sensor(args, uid, generation) {
    // args
    // 0     variable name (including s_ variables)
    // 1     sensorsize
    // 2     mode
    // 3     das_blinken_rate
    // 4     oncolor
    // 5     offcolor
    // 6     rimcolor
    // 7     x
    // 8     y

    if (!(uid in amllib_objects)) {
        var svgns = 'http://www.w3.org/2000/svg';
        var svg = document.createElementNS(svgns, 'svg');
        var circle = document.createElementNS(svgns, 'circle');

        circle.id = 'sensor_' + args[0];

        svg.style.height = '1em';
        svg.style.width = '1em';
        circle.setAttributeNS(null, 'cx','50%');
        circle.setAttributeNS(null, 'cy', '50%');
        circle.setAttributeNS(null, 'r', '40%');
        svg.appendChild(circle);
        svg.style.display = 'none'; // don't draw yet
        container.appendChild(svg);

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].type = 'sensor';
        amllib_objects[uid].variable = args[0];
        amllib_objects[uid].object = svg;
        amllib_objects[uid].circle = circle;
        amllib_objects[uid].oncolor = args[4];
        amllib_objects[uid].offcolor = args[5];
        amllib_objects[uid].rimcolor = args[6];
        amllib_objects[uid].sensorAnimate = [
            { fill: makergb(args[4]) },
            { fill: makergb(args[5]) },
            { fill: makergb(args[4]) }
        ];
        amllib_objects[uid].draw = aml_sensor_draw;
        amllib_objects[uid].hide = aml_sensor_hide;

        aml_add_var(args[0], false);
    }
    else {
        svg = amllib_objects[uid].object;
        circle = amllib_objects[uid].circle;
        amllib_objects[uid].generation = generation;
    }

    get_cursor ();
    svg.style.position = 'absolute';
    // circle should be positioned at center = (args[7], args[8])
    // but we need to position the svg container instead
    // svg container is 1em tall/wide 
    // 1em is 10% because container has set font-size at 1/10 window height
    // so subtract 5% from both bottom and left to get circles in the right places
    svg.style.bottom = ((100 - y_percent(args[8])) - 5) + '%';
    svg.style.left = (args[7] - 5) + '%';
}
function aml_sensor_draw(uid) {
    var svg = amllib_objects[uid].object;
    var circle = amllib_objects[uid].circle;
    var variable = amllib_objects[uid].variable;
    var sensorAnimate = amllib_objects[uid].sensorAnimate;
    var sensorActive = get_value(variable);

    if (sensorActive == 2) {
        // flashing
        circle.setAttributeNS(null, 'style',
                              'fill:' + makergb(amllib_objects[uid].oncolor) + 
                              '; stroke:' + makergb(amllib_objects[uid].rimcolor) +
                              ';stroke-width:2');
        // XXX not sure how to translate "das blinken rate" to duration here
        circle.animate(sensorAnimate, { duration: 2000,
                                        fill: 'backwards',
                                        iterations: Infinity });
    }
    else if (sensorActive == 1) {
        // on
        circle.setAttributeNS(null, 'style',
                              'fill:' + makergb(amllib_objects[uid].oncolor) + 
                              '; stroke:' + makergb(amllib_objects[uid].rimcolor) +
                              ';stroke-width:2');
        // XXX there must be a better way of turning off animation than setting
        //     the object to animate between two identical fill values...
        circle.animate([{fill: makergb(amllib_objects[uid].oncolor)},
                        {fill: makergb(amllib_objects[uid].oncolor)}], 
                       { duration: 0, iterations: 1 })
    }
    else {
        // off
        circle.setAttributeNS(null, 'style',
                              'fill:' + makergb(amllib_objects[uid].offcolor) + 
                              '; stroke:' + makergb(amllib_objects[uid].rimcolor) +
                              ';stroke-width:2');
        // XXX there must be a better way of turning off animation than setting
        //     the object to animate between two identical fill values...
        circle.animate([{fill: makergb(amllib_objects[uid].offcolor)},
                        {fill: makergb(amllib_objects[uid].offcolor)}], 
                       { duration: 0, iterations: 1 })
    }
    svg.style.display = 'block';
}
function aml_sensor_hide(uid) {
    var svg = amllib_objects[uid].object;
    svg.style.display = 'none';
}
function aml_show_objects(generation) {
    for (var uid in amllib_objects)
        if (amllib_objects[uid].generation == generation)
            if ('draw' in amllib_objects[uid])
                amllib_objects[uid].draw(uid);
}
function aml_strlen(s, uid, generation) {
    return s.length;
}
function aml_textedit_var(args, uid, generation) {
    // args
    // 0    variable name
    // 1    savemode
    // 2    fontsize
    // 3    color
    // 4    x
    // 5    y
    // 6    nchars

    var variable = args[0];
    var savemode = args[1];
    var fontsize = args[2];
    var color = args[3];
    var x = args[4];
    var y = args[5];
    var nchars = args[6];

    var val = get_value(args[0]);

    if (!(uid in amllib_objects)) {
        // create element and add it to document
        var inputnode = document.createElement('input');
        inputnode.id = 'textedit_' + args[0];
        inputnode.type = 'text';
        // inputnode.size = nchars;
        inputnode.style.width = nchars + 'ch';
        inputnode.style.verticalAlign = 'text-bottom';
        inputnode.style.fontSize = font_size(args[2]);
        // inputnode.style.color = makergb(color);
        inputnode.style.color = 'black';
        inputnode.style.backgroundColor = makergb(0xffffff);
        if ('border' in amllib_options)
            inputnode.style.border = amllib_options.border;
        else {
            inputnode.style.border = '2px';
            inputnode.style.borderRadius = '0.25em';
            inputnode.style.boxShadow = '0 1px 2px rgba(0,0,0,0.2)';
        }
        // inputnode.style.paddingTop = '0.25em';
        // inputnode.style.paddingBottom = '0.0em';
        // inputnode.style.paddingLeft = '0.25em';
        // inputnode.style.paddingRight = '0.25em';
        inputnode.style.paddingTop = '0.0em';
        inputnode.style.paddingBottom = '0.0em';
        inputnode.style.paddingLeft = '0.0em';
        inputnode.style.paddingRight = '0.0em';
        inputnode.style.textAlign = 'left';
        inputnode.style.cursor = 'pointer';
        inputnode.style.outline = 'none';
        inputnode.style.textDecoration = 'none';
        inputnode.style.textShadow = '0 1px 1px rgba(0,0,0,0.3)';
        inputnode.style.display = 'none'; // don't draw yet
        container.appendChild(inputnode);
        inputnode.onkeyup = aml_textedit_var_change;
        inputnode.onchange = aml_textedit_var_change;
        
        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].id = inputnode.id;
        amllib_objects[uid].object = inputnode;
        amllib_objects[uid].type = 'textedit-var';
        amllib_objects[uid].variable = args[0];
        amllib_objects[uid].draw = aml_textedit_var_draw;
        amllib_objects[uid].hide = aml_textedit_var_hide;

        aml_add_var(args[0], true);
    }
    else {
        inputnode = amllib_objects[uid].object;
        amllib_objects[uid].generation = generation;
    }

    get_cursor ();
    inputnode.style.position = 'absolute';
    inputnode.style.left = x + "%";
    y = y_percent(args[5]);
    inputnode.style.bottom = ((100.0 - y) - bottom_fudge(args[2])) + "%";

    inputnode.value = val;
}
function aml_textedit_var_change() {
    var uid = find_uid_by_id (this.id);

    if (uid >= 0) {
        var varname = amllib_objects[uid].variable;
        var object = amllib_objects[uid].object;
        var value = get_value(varname);

        if (value != object.value) {
            set_value(varname, object.value);
        }
    }
}
function aml_textedit_var_draw (uid) {
    var object = amllib_objects[uid].object;
    var variable = amllib_objects[uid].variable;

    object.value = get_value(variable);
    object.style.display = 'block';
}
function aml_textedit_var_hide (uid) {
    var object = amllib_objects[uid].object;

    object.style.display = 'none';
}
function aml_textlen(args, uid, generation) {
    // args
    // 0    string variable name
    // 1    this was supposed to be a font size but it doesn't really 
    //      matter because the whole idea was to get a relative sense
    //      of how long the string is when formatted, independent of
    //      what font is used -km per rf
    var text = document.createTextNode(args[0]);
    var div = document.createElement('div')
    div.style.fontSize = 10;    // XXX arbitrary setting
    div.style.position = 'absolute';
    div.style.visibility = 'hidden';
    div.style.height = 'auto';
    div.style.width = 'auto';
    div.style.whiteSpace = 'nowrap';
    div.appendChild(text);
    container.appendChild(div);
    // 9.44 is an empirically determined fudge factor designed to make
    // this implementation of textlen() produce about the same result 
    // as the one for the touchscreen.
    //
    // Also, I got this code from the net.  I don't know what the +1 is for
    // except maybe to make sure that some result is returned even if
    // for whatever reason there's no clientWidth field.
    // -km
    return (div.clientWidth + 1) * 9.44;
}
function aml_toggle(args, uid, generation) {
    // args
    // 0    variable name
    // 1    [optional?] savemode (save/nosave/noallow/unsave)
    // 2    fontsize
    // 3    fgcolor
    // 4    bgcolor
    // 5    x
    // 6    y
    // 7    number of choices
    // 8    choice1
    // 9    choice2
    //      ...
    
    if (args[1] == "save") {
        savemode = args[1];
        fsarg = 2;
    }
    else if (args[1] == "autosave") {
        savemode = args[1];
        fsarg = 2;
    }
    else if (args[1] == "nosave") {
        savemode = args[1];
        fsarg = 2;
    }
    else if (args[1] == "noallow") {
        savemode = args[1];
        fsarg = 2;
    }
    else if (args[1] == "unsave") {
        savemode = args[1];
        fsarg = 2;
    }
    else {
        // XXX should be error?
        savemode = "nosave";
        fsarg = 1;
    }
    n_choices = args[fsarg+5];
    if ((args.length - 7) < n_choices) {
        n_choices = args.length - 7;
    }

    if (!(uid in amllib_objects)) {
        var t = document.createElement('div');
        var textnode = document.createTextNode('')
    
        t.id = 'toggle_' + args[0];
        t.onclick = aml_toggle_onclick;
        t.style.verticalAlign = 'text-bottom';
        t.style.fontSize = font_size(args[fsarg]);
        t.style.color = makergb(args[fsarg+1]);
        if (makergb(args[fsarg+1]) == '#000000') {
            // zero padding if black background
            t.style.paddingTop = '0.0em';
            t.style.paddingBottom = '0.0em';
            t.style.paddingLeft = '0.0em';
            t.style.paddingRight = '0.0em';
        }
        else {
            // else color padding on right, left, and top
            // XXX this doesn't always look right either
            t.style.paddingTop = '0.25em';
            t.style.paddingBottom = '0.0em';
            t.style.paddingLeft = '0.25em';
            t.style.paddingRight = '0.25em';
        }
        t.style.backgroundColor = makergb(args[fsarg+2]);
        if ('border' in amllib_options)
            t.style.border = amllib_options.border;
        else {
            t.style.border = '2px';
            t.style.borderRadius = '0.25em';
            t.style.boxShadow = '0 1px 2px rgba(0,0,0,0.2)';
        }
        t.style.textAlign = 'center';
        t.style.cursor = 'pointer';
        t.style.outline = 'none';
        t.style.textDecoration = 'none';
        t.style.textShadow = '0 1px 1px rgba(0,0,0,0.3)';
        t.style.display = 'none'; // don't draw yet
        t.appendChild(textnode);
        container.appendChild(t);

        amllib_objects[uid] = {};
        amllib_objects[uid].generation = generation;
        amllib_objects[uid].type = 'toggle';
        amllib_objects[uid].variable = args[0];
        amllib_objects[uid].object = t;
        amllib_objects[uid].textnode = textnode;
        amllib_objects[uid].toggle_choices = args.slice(8, 8 + n_choices);
        amllib_objects[uid].num_choices = n_choices;
        amllib_objects[uid].savemode = savemode;
        amllib_objects[uid].draw = aml_toggle_draw;
        amllib_objects[uid].hide = aml_toggle_hide;

        aml_add_var(args[0], true);
    }
    else {
        t = amllib_objects[uid].object;
        textnode = amllib_objects[uid].textnode;
        amllib_objects[uid].generation = generation;
    }
    get_cursor ();
    t.style.position = 'absolute';
    t.style.left = args[fsarg+3] + "%";
    y = y_percent(args[fsarg+4]);
    t.style.bottom = ((100.0 - y) - bottom_fudge(args[fsarg])) + "%";
}
function aml_toggle_draw (uid) {
    var t = amllib_objects[uid].object;
    var textnode = amllib_objects[uid].textnode;
    var toggle_choices = amllib_objects[uid].toggle_choices;
    var n_choices = amllib_objects[uid].num_choices;
    var variable = amllib_objects[uid].variable;

    num = get_value(variable);
    if ((num < 0) || (num >= n_choices)) {
        text = 'ERROR';
    }
    else {
        text = toggle_choices[num];
    }
    textnode.textContent = text;
    t.style.display = 'block';
}
function aml_toggle_hide (uid) {
    var t = amllib_objects[uid].object;

    t.style.display = 'none';
}
function aml_toggle_onclick(e) {
    var uid = find_object_uid (e);
    var savemode = amllib_objects[uid].savemode;
    var varname = amllib_objects[uid].variable;
    var lcvarname = varname.toLowerCase();
	var toggle_choices = amllib_objects[uid].toggle_choices;
    var value = get_value(varname);

    if (savemode == 'noallow') {
        // not sure what the point of this is
		// well...
		// the point is that a value of a toggle can be displayed, but not modified by user, only by instrument.
		// a grep of the files for 'noallow' would have provided illumination, but being angry in the dark is easier, apparently
		//
    }
    else if (savemode == 'nosave') {
        // change local value of variable but don't save?
        if (lcvarname in amllib_vars && amllib_vars[lcvarname].initialized) {
            var modified = amllib_vars[lcvarname].modified;
            value = (value + 1) % amllib_objects[uid].num_choices;
            if(toggle_choices[value] == "")
			{
				value = (value + 1) % amllib_objects[uid].num_choices;
			}
			set_value(varname, value);
            amllib_vars[lcvarname].modified = modified;
            aml_toggle_draw(uid);
        }        
    }
    else if (savemode == 'save') {
        // change local value of variable and save when SAVE is hit??
        if (lcvarname in amllib_vars && amllib_vars[lcvarname].initialized) {
            value = (value + 1) % amllib_objects[uid].num_choices;
            if(toggle_choices[value] == "")
			{
				value = (value + 1) % amllib_objects[uid].num_choices;
			}
            set_value(varname, value);
            aml_toggle_draw(uid);
        }
    }
    else if (savemode == 'autosave') {
        // change local value of variable and save this variable immediately?
        if (lcvarname in amllib_vars && amllib_vars[lcvarname].initialized) {
            value = (value + 1) % amllib_objects[uid].num_choices;
            if(toggle_choices[value] == "")
			{
				value = (value + 1) % amllib_objects[uid].num_choices;
			}
            set_value_u(varname, value);
            aml_toggle_draw(uid);
        }
        amllib_autosave_vars.push(varname);
        amllib_autosave_requested = true;
        aml_poll_now();
    }
}
amllib_autofillmodelabelcolors = {
    0: { 0: 0x00ff00, 1: 0x00ff00}, // green, green
    1: { 0: 0x000080, 1: 0x000080}, // darkblue, darkblue
    2: { 0: 0xff0000, 1: 0x800000}, // red, darkred
    3: { 0: 0xff0000, 1: 0x800000}  // red, darkred
};
amllib_autofillstatelabelcolors = {
    0: { 0: 0x333333, 1: 0x333333 }, // darkgrey, darkgrey
    1: { 0: 0x00ff00, 1: 0x00ff00 }, // green, green
    2: { 0: 0x0000ff, 1: 0x000080 }, // blue, darkblue
    3: { 0: 0x0000ff, 1: 0x000080 }, // blue, darkblue
    4: { 0: 0xff0000, 1: 0x800000 }, // red, darkred
    5: { 0: 0xff0000, 1: 0x800000 }, // red, darkred
    6: { 0: 0xffff00, 1: 0x808000 }  // yellow, darkyellow
};
function aml_update_fill_colors() {
    amllib_blinkstate = 1 - amllib_blinkstate;
    var autofill1mode = get_value('AutoFill1Mode');
    var autofill1color = get_value('AutoFill1State');
    var autofill2color = get_value('AutoFill2State');

    amllib_vars['c_autofill'].current_value = 
        amllib_autofillmodelabelcolors[autofill1mode % 4][amllib_blinkstate];
    amllib_vars['c_autofill'].cancel_value = 
        amllib_autofillmodelabelcolors[autofill1mode % 4][amllib_blinkstate];
    amllib_vars['c_autofill1'].current_value = 
        amllib_autofillstatelabelcolors[autofill1color % 7][amllib_blinkstate];
    amllib_vars['c_autofill1'].cancel_value = 
        amllib_autofillstatelabelcolors[autofill1color % 7][amllib_blinkstate];
    amllib_vars['c_autofill2'].current_value = 
        amllib_autofillstatelabelcolors[autofill2color % 7][amllib_blinkstate];
    amllib_vars['c_autofill2'].cancel_value = 
        amllib_autofillstatelabelcolors[autofill2color % 7][amllib_blinkstate];
}
window.onload = function() {
    aml_keep_aspect_ratio('container', 480, 272);
    window.onresize = function (event) {
        aml_keep_aspect_ratio('container', 480, 272);
    };
};


/*
 * (this tells emacs to not use HTABs for indenting)
 * Local Variables:
 * tab-width: 4
 * indent-tabs-mode: nil
 * End:
 */
